 %[time1,vapPen1,ang1]=aviV('c:\pickett\papers\Congress07\liquid\bicdg410\a'
%,'dum',15:200,15,34.5,160,0.3,1,1/5.3375,[62 -5]);

% Original aviV calling function:
%function [time,vapPen,tan2,JB,maxV,JBa]=aviV(cinefile,filename,imgNums,injfr,endinj,thresh,opt,scale,orgn)
function [x,y,maxJ,minJ]=JBaviV(testImage1,testImage2,showfigs,x_c, ...
    strip,threshval,num_erodes,num_dilates,downstreamStrip,TopStrip, ...
    BottomStrip,XMark,YMark,mask,liqCoreMask,complement)
%        [x,y,maxJ,minJ]=JBaviV(TestImage1,TestImage2,1       ,Input1,Input2,Input3   ,Input4    ,Input5     ,Input6         , Input7 , Input8    ,XMark,YMark,mask)

% Function implemented from aviV.m
% Not sure how it works yet... -RKG 9/4/09 

nColumns = size(testImage1,2);
nRows    = size(testImage1,1);

% Error check the region of interest inputs:
if strip > nColumns
    strip = nColumns;
end
if downstreamStrip > nColumns
    message = {'Exceeded possible value for downstreamStrip.'; ...
              ['Maximum value = ' sprintf('%d pixels',nColumns)]};
    errordlg(message)
    return
end
if TopStrip > nRows
    TopStrip = nRows;
end
if BottomStrip > nRows
    BottomStrip = nRows;
end

% Arguments that are not yet passed in:
opt = 0; % If 0, adds edge detection from original image
orgn = [YMark,x_c]; % Origin is not yet passed in [y,x]


% Create a 'ball' structuring element:
seBallRadius = 3;
seBallHeight = 1;
seBallN      = 8;
%seBall = strel('ball',seBallRadius,seBallHeight,seBallN); % was se
%seBall = strel('line',8,0);
se1 = [0 0 0 0 0 1 0 0; ...
       0 0 0 1 1 1 1 0; ...
       1 1 1 1 1 1 1 1; ...
       0 0 0 1 1 1 1 0; ...
       0 0 0 0 0 1 0 0];
he1 = [0.0 0.0 0.0 0.0 0.0 .25 0.0 0.0; ...
       0.0 0.0 0.0 0.5 .70 .70 .80 0.0; ...
       .25 .30 .40 .70 .90 1.0 .90 .80; ...
       0.0 0.0 0.0 0.5 .70 .70 .80 0.0; ...
       0.0 0.0 0.0 0.0 0.0 .25 0.0 0.0];
seBall = strel(se1,he1);


% Create a 'disk' structuring element:
seDiskRadius = 2;
seDiskN      = 4;
seDisk = strel('disk',seDiskRadius,seDiskN); % was seb

% Subtract a previous image from the current image and add a brightness
% factor
Y  = double(testImage1)-double(testImage2)+2000;

% Find an edge by subtracting a dilated image from an eroded image using
% the specified structuring element.
Yd = imdilate(Y,seBall);
Ye = imerode (Y,seBall);
YEdge= (Yd-Ye);

Yb = im2bw(double(YEdge)/4096,threshval);
if complement
    Yb = imcomplement(Yb);
end
Yb = Yb & mask;
%Yb=im2bw(double(YEdge)/4096,threshval) & mask;
Xb=0;                                                                      %#ok<NASGU>

if opt==0 % Adds an edge detection from original image.
    Xd = imdilate(testImage1,seBall);
    Xe = imerode (testImage1,seBall);
    XEdge = 4096 - (Xd-Xe);
    Xb = im2bw(double(XEdge)/4096,threshval*1.0) & mask;                   %#ok<NASGU>
    %         [b]=jetBoundary(Xb);
    %         [S]=max(b(:,2));
    %         XbTip=im2bw(double(XEdge)/256,thresh*1.5) & mask;
    %         Xb=medfilt2(Xb,mfilt);
end

%ORs the edge find to original with mult 1.2 
Yb = Yb | Xb ; 
%figure(2),imagesc(Yb),colormap(gray)

% Set the first N number of indices to zero... why?
minInd = 1;
Yb(:,1:minInd)=0;
JET = Yb;                                                                  %#ok<NASGU>

% Ignore other regions not of interest (not covered by mask)
JET(:,1:strip)=0;                   % Make strip next to injector 0
JET(:,downstreamStrip:nColumns)=0;  % Make downstream strip 0
JET(1:TopStrip,:)=0;                % Make top strip 0
JET(nRows-BottomStrip:nRows,:)=0;   % Make bottom strip 0

% Applies a mask designed to block in the unmoving liquid core that often
% does not get included in the jet using the various techniques.
if liqCoreMask % Another user option - can be turned off
    JET = applyLiqCoreMask(JET,orgn);
end

% Labels connected components in image
%L = bwlabel(JET,4); % Find the already connected regions within the input image IM 
L = logical(JET);
if isempty(XMark)==0; % Test if a location for the X mark has been supplied
    
    % Was the mark position calculated as being too far out?
    if XMark > nColumns 
        % If so, divide by 2 and hope for the best
        XMark = nColumns/2;
    end
    try
        LabelNum = L(round(YMark),round(XMark)); % If it has then find the region under the mark X
    catch exc
        LabelNum = 1;
        disp(exc)
    end
else
    RegionAreas = regionprops(L, 'area'); % If it hasn't then find the largest region
    Area = cat(1, RegionAreas.Area);
    LabelNum=find(Area==max(Area));
end

if isempty(LabelNum)
    x=[];y=[];maxJ=[];minJ=[];
    return
end
if LabelNum == 0
    x=[];y=[];maxJ=[];minJ=[];
    return
end

JET(L==LabelNum)=1;  %fill JET with just the largest region

% Perform erode/dilate operations
JET = imfill(JET,'holes');
JET = bwmorph(JET,'erode',num_erodes); 
JET = bwmorph(JET,'dilate',num_dilates); 
JET = imfill(JET,'holes');

% Perform the liquid core mask again in case erode operations removed it.
if liqCoreMask && num_erodes > 0
    JET = applyLiqCoreMask(JET,orgn);
end
%JET=imclose(JET,seDisk);

% erodes can form disconnected regions to form, this part keeps the
% region that's still under the X
%L = bwlabel(JET,8); %Find the already connected regions within the input image IM 
L = logical(JET);
RegionAreas = regionprops(L, 'area');
Area = cat(1, RegionAreas.Area);
LabelNum=find(Area==max(Area));
if isempty(LabelNum) == 1; % the region has been eroded to nothing!!!
    x=[];y=[];return;
end

if isempty(XMark)==0; % test if a location for the X mark has been surplied
    try
        LabelNum = L(round(YMark),round(XMark)); % if it has then find the region under the mark X
    catch exc
        LabelNum = 1;
        disp(exc)
    end
end

if isempty(LabelNum) == 1 || LabelNum == 0;
    x=[];y=[];return;
end  

JET = zeros(size(JET));
JET(L==LabelNum)=1;

% find the boundary of the region to send back to the GUI as x,y coordinates
%Also send back max and min
JetBoundary = bwboundaries(JET);                                           %#ok<NASGU>
[r,c]=find(JET); 
if ~isempty(c) 
    maxJ=max(c);
    minJ=min(c);
else
    maxJ=0; minJ=100;
end

% Tim's boundary saving method
JetBoundary = bwboundaries(JET);
x = JetBoundary{1}(:,2);
y = JetBoundary{1}(:,1);

% No longer used...
if showfigs==1
end


