function [time,LB,maxL,minL]=aviCineFuel(cinefile,filename,imgNums,injfr,EOIfr,scale,orgn,NonReactingJetorgn,NonReactinginjfr,NonReactingJetBoundfile,Sootorgn,SootLuminosityBoundfile,gRng, CRng, timg)
fprintf('%s\n',cinefile)
fprintf('%s\n',NonReactingJetBoundfile)
fprintf('%s\n',SootLuminosityBoundfile)
%load rgb.mat
if nargin<6 scale = 1/5.3875; end %5.3875 pixels = 1mm
if nargin<7 orgn = [62 -5]; end % 
if nargin<8 NonReactingJetorgn = [62 -5]; end % 
if NonReactingJetBoundfile % show previously processed non-reacting jet boundary using SchlerenFuelJets.m
    load(NonReactingJetBoundfile, '-mat'); %lots of information in JB cell matrix
end
if SootLuminosityBoundfile %show previously processed high-speed soot boundary using HSSootProcess.m
    load(SootLuminosityBoundfile); % time & LB cell matrix
end
if nargin<11 gRng = [75 60 33*16 7.5*16]; end % 
if nargin<12 CRng=[0 500]; end %

[d] = readcine(cinefile,[imgNums(1),imgNums(end)]);Acqper=1e6/d.CameraSetup.FrameRate;
im1=d.Images.RawImages(:,:,1)';
dimIm=size(im1);
xval = ([1:dimIm(2)]-orgn(2))*scale; rad = ([1:dimIm(1)]-orgn(1))*scale;
 xind=[xval(1) xval(end)]; yind=[rad(1) rad(end)];
 yr=[-18 18]; xr=[0 90]; xt=[10:10:100]; yt=[-10:10:10];
clear M 
figure(12); clf;

j=0;
for i=imgNums(1):imgNums(end)
    k=i-imgNums(1)+1;
    timetime(i)=round((i-injfr)*Acqper);
    timeEOI=round((i-EOIfr)*Acqper);
    
    X=flipud(double(d.Images.RawImages(:,:,k)'));
    X=medfilt2(X,[3 3]);
    figure(12), clf 
    %imshow(X,CRng,'XData',xind,'Ydata',yind,'InitialMagnification',100) %for D2
    imshow(X,CRng,'XData',xind,'Ydata',yind,'InitialMagnification',200)
    set(gca,'Visible','on','TickDir','out','XTick',xt,'YTick',yt,...
        'LineWidth',2,'Xlim',xr,'Ylim',yr,'FontSize',20)%'Xgrid','on','Xcolor','g');

    if NonReactingJetBoundfile      
        ScaleJB = JB{1,14}(1,1);
        InjStartFrame = NonReactinginjfr;
        FrameRateJB = JB{1,14}(1,5);
        for jj=InjStartFrame:length(JB)
            timeJB(jj) = 10^6*(jj - InjStartFrame)./FrameRateJB; %micro second
        end

        b=find(timeJB>timetime(i));
        if ~isempty(b)
            CurrentFrame=b(1);
        else
            CurrentFrame = 1;
        end
        if ~isempty(JB{CurrentFrame,11})
            x = JB{CurrentFrame,11}(:,1);   %x locations of boundary
            y = JB{CurrentFrame,11}(:,2);   %y locations of boundary
            x_mm = (x - NonReactingJetorgn(2)) * ScaleJB; y_mm = (y - NonReactingJetorgn(1)) * ScaleJB;
            hold on, plot(x_mm, y_mm, ':c','LineWidth',3);
        end
    end;
    
          
    if SootLuminosityBoundfile
        a=find(time>timetime(i));
        if ~isempty(a)
            nL=a(1);
        else
            nL = 1;
        end
        hold on; 
        for k=1:length(LB{1,nL})
            plot(LB{1,nL}{k,1}(:,2)+Sootorgn(1),LB{1,nL}{k,1}(:,1)+Sootorgn(2),'r','LineWidth',3);
        end
    end
    
    %plot([LiftOH LiftOH],[-10 10],'--r');

    set(gcf,'Color','w')

    %text(6,14,num2str(i),'fontsize',14,'color',[1 0 1]);
       if i <= EOIfr
            text(6,-14,[num2str(timetime(i)) ' \mus'],'fontsize',22,'color',[1 1 1],'backgroundcolor',[0 0 0]);
       else
            text(6,-14,[num2str(timetime(i)) ' \mus'],'fontsize',22,'color',[0 1 0],'backgroundcolor',[0 0 0]);
       end
  j=j+1;
  M(j)=getframe(gcf,gRng); 
  t(j)=timetime(i);
  Mscl=getframe(gcf,[gRng(1) gRng(2)-27 gRng(3) gRng(4)/10]);
end

%%optional
%make figure of time sequence
%specify time interval
if 1
    num =length(timg); figure(13), clf; Xc=[];
        for i=1:num
            %if length(timg)>20 return; end
            %a=find(t>timg(i)-20);
            a = timg(i);
            [X,map]=frame2im( M(a) );
           Xc=[Xc; X;];
        end
        Xc=[Xc; frame2im(Mscl);]; %adds scale to bottom of images
    figure(13), imshow(Xc)
end

if 1
 fprintf('writing AVI file...\t');
 movie2avi(M,filename,'fps',10,'compression','none');
 fprintf('done\n');
end