function varargout = schlierenFuelJets(varargin)
% SCHLIERENFUELJETS M-txtfile for schlierenFuelJets.fig

% Last Modified by GUIDE v2.5 25-Jul-2011 17:31:06

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @schlierenFuelJets_OpeningFcn, ...
                   'gui_OutputFcn',  @schlierenFuelJets_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
     gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT
function schlierenFuelJets_OpeningFcn(hObject, eventdata, ...
                                      handles, varargin)                   %#ok<*INUSL>
% Choose default command line output for schlierenFuelJets
handles.output = hObject;

% Add the fig edtfilename and installation directory to handles structure
handles.figFilePath = get(handles.output,'FileName');
pathTerm = findstr(handles.figFilePath,'\');
pathTerm = pathTerm(end);
handles.installDir = handles.figFilePath(:,1:pathTerm);
handles.JBisAlreadySaved = 0;
% Place the figure toolbar into the GUI window (for zooming, panning, etc.)
%set(hObject,'Toolbar','figure')

% Update handles structure
guidata(hObject, handles);
function varargout = schlierenFuelJets_OutputFcn(hObject, eventdata, ...
                                                 handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure

% Get default command line output from handles structure
varargout{1} = handles.output;


% Due to the large nature of this m-file the following style guidelines are
% suggested throughout for sanity purposes:
% 1. Callbacks should be separated into sections corresponding to main
%    panels in the GUI.
% 2. Each main panel should have a segment set apart by a title (see below)
% 3. Separate callbacks from create functions.

% -RKG

% -------------------------------------------------------------------------
%                           File Selection 
% -------------------------------------------------------------------------

% File Selection Callbacks
function btnBrowse_Callback(hObject, eventdata, handles)                   %#ok<*DEFNU>
%--- Interactively browse txtfile location and cine txtfile ---

global filename pathname initialdirectory imageCount firstImageNumber 
global O2 Temp Density InjPress Orifice frameRate16

initialdirectory = pwd;

% Try to go to the last folder used by the program.
if exist([handles.installDir 'pathname.mat'],'file')
    load([handles.installDir 'pathname.mat'],'pathname'); 
    try
        cd(pathname)
    catch exc
        disp(exc)
    end
else
    % Default pathname if no pathname txtfile found
    pathname = 'c:\';                                                      %#ok<NASGU> 
end
[filename, pathname] = uigetfile( ...
	{'*.cin*', 'All SPE-Files (*.cin or *.cine)';
     '*.mat' , 'All *.mat files'}, ...
	'Select .cine or .mat File');


% Handle the "Cancel" case.
if isequal([filename,pathname],[0,0])  
	cd(initialdirectory);
    return
end

% If not cancelled, change directory to selected
cd(pathname)

% Save the current directory for next program use.
save([handles.installDir 'pathname.mat'],'pathname');

% Handle the case of a non-standard file (*.mat of images)


% Construct a full file path and update GUI file path boxes
% [p, n, ext, v] = fileparts(fullfile(pathname,filename));                   %#ok<NASGU>
[p, n, ext] = fileparts(fullfile(pathname,filename));                   %#ok<NASGU>
if strcmp(ext,'.cin')
    cineNamePath = strrep(fullfile(pathname,filename),'.cin','');
elseif strcmp(ext,'.cine')
    cineNamePath = strrep(fullfile(pathname,filename),'.cine','');
elseif strcmp(ext,'.mat')
    matFile = fullfile(pathname,filename);
    % For compatibility with cine files:
    cineNamePath = strrep(fullfile(pathname,filename),'.mat',''); 
else
    errordlg('File not found!')
    return
end

set(handles.edtFileLocation, 'String', pathname);
set(handles.edtFileName,     'String', filename);

if strcmp(ext,'.mat') % Can handle imported data from IFP (Paris). see ifpImageConvert.m
    load(matFile);
    frameRate16 = double(frameRate16);
    % First image frame number (from imgNums)
    set(handles.txtFirstImageNumber, 'String', firstImageNumber);
    
    % Get/Set total number of frames in the mat file
    set(handles.txtImageCount, 'String', num2str(imageCount));
    
    % Default load all frames
    set(handles.edtTotalFrames, 'String', num2str(imageCount));
    
    % Get the frame rate from the camera
    set(handles.txtFrameRate16, 'String', num2str(frameRate16));
    
    % Set filename
    set(handles.txtFile,              'String', filename);
    
    % Set experiment parameters
    set(handles.txtO2Percentage,      'String', O2);
    set(handles.txtTemperature,       'String', Temp);
    set(handles.txtDensity,           'String', Density);
    set(handles.txtInjectionPressure, 'String', InjPress);
    set(handles.txtOrificeDiameter,   'String', Orifice);
    
else
    % Load one image to update header information.
    imdata = readcin(cineNamePath,[1,1]);
    % Get the frame number of the first frame
    firstImageNumber = imdata.CineHeader.FirstImageNumber;
    set(handles.txtFirstImageNumber, 'String', firstImageNumber); 

    % Get total number of frames in the cine file
    imageCount = imdata.CineHeader.ImageCount; 
    set(handles.txtImageCount, 'String', imageCount);

    % Default load all frames
    imageCount = imdata.CineHeader.ImageCount; 
    set(handles.edtTotalFrames, 'String', imageCount);

    % Get the frame rate from the camera
    frameRate16 = imdata.CameraSetup.FrameRate16; 
    set(handles.txtFrameRate16, 'String', frameRate16);

    % Display Experiment Information from the txtfile name information
    [O2,Temp,Density,InjPress,Orifice]=dcsfFileExtract(filename);
    InjPress = InjPress * 0.00689475728; % Conversion to MPa from psi
    set(handles.txtFile,              'String', filename);
    set(handles.txtO2Percentage,      'String', O2);
    set(handles.txtTemperature,       'String', Temp);
    set(handles.txtDensity,           'String', Density);
    set(handles.txtInjectionPressure, 'String', InjPress);
    set(handles.txtOrificeDiameter,   'String', Orifice);
end

% Enable the load buttons on the GUI
set(handles.btnLoadCine,                      'Enable',          'On'); 
set(handles.edtStartFrame,                    'Enable',          'On'); 
set(handles.edtTotalFrames,                   'Enable',          'On'); 
set(handles.btnLoadJB,                        'Enable',          'On'); 
set(handles.ckbLoadSameFrameNumbers,          'Enable',          'On'); 
function edtCurrentFileName_Callback(hObject, eventdata, handles)
function edtFileLocation_Callback(hObject, eventdata, handles)             %#ok<*INUSD>
function edtFileName_Callback(hObject, eventdata, handles)
global filename pathname frameRate16
filename = get(handles.edtFileName,    'String');
pathname = get(handles.edtFileLocation,'String');
%test = strfind(filename,'.cine');
%if isempty(test)==1; 
%    filename = [filename,'.cine'];
%    set(handles.edtFileName, 'String', filename);
%end

% --- Update header info ---

% Construct a full file path and update GUI file path boxes
% Strip the *.cin in preparation for the readcin function
cineNamePath = strrep(fullfile(pathname,filename),'.cin','');

% Load one image to update header information.
imdata = readcin(cineNamePath,[1,1]);
imSize(1) = imdata.CameraSetup.ImWidth;
imSize(2) = imdata.CameraSetup.ImHeight;
% Get the frame number of the first frame
firstImageNumber = imdata.CineHeader.FirstImageNumber;
set(handles.txtFirstImageNumber, 'String', firstImageNumber);

% Get total number of frames in the cine file
imageCount = imdata.CineHeader.ImageCount;
set(handles.txtImageCount, 'String', imageCount);

% Get the frame rate from the camera
frameRate16 = imdata.CameraSetup.FrameRate16;
set(handles.txtFrameRate16, 'String', frameRate16);
    
% Update Experiment Info
[O2,Temp,Density,InjPress,Orifice]=dcsfFileExtract(filename);
set(handles.txtFile,              'String', filename(1:8));
set(handles.txtO2Percentage,      'String', O2);
set(handles.txtTemperature,       'String', Temp);
set(handles.txtDensity,           'String', Density);
set(handles.txtInjectionPressure, 'String', InjPress);
set(handles.txtOrificeDiameter,   'String', Orifice);
    
% Enable buttons/inputs on the GUI
set(handles.btnLoadCine,    'Enable', 'On');
set(handles.edtStartFrame,  'Enable', 'On');
set(handles.edtTotalFrames, 'Enable', 'On');

% File Selection Create Functions
function edtCurrentFileName_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtFileLocation_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtFileName_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





% -------------------------------------------------------------------------
%      Load Subset of Cine into GUI or Load/Save JB into/from GUI
% -------------------------------------------------------------------------

% Load Subset of Cine Callbacks
function btnLoadCine_Callback(hObject, eventdata, handles)

global filename pathname startFrame totalFrames images offsetWrite 
global offsetRead currentFrame Perimeter JB imageCount firstImageNumber 
global t1 frameRate16

% --- Enable the buttons/inputs on the GUI ---

% Current Frame (Navigation controls)
set(handles.btnPreviousFrame,      'Enable',          'On');     
set(handles.btnNextFrame,          'Enable',          'On'); 
set(handles.edtCurrentFrame,       'Enable',          'On');  
set(handles.edtStepSize,           'Enable',          'On');     
set(handles.btnLoop,               'Enable',          'On'); 
set(handles.rdbStop,               'Enable',          'On'); 


% Scale and Start Frame
set(handles.btnSave,               'Foregroundcolor', 'Red');  
set(handles.btnUnlock,             'Enable',          'Off');   
set(handles.edtScaleFile,          'Enable',          'On'); 
set(handles.edtInjStartFrame,      'Enable',          'On'); 



set(handles.btnSave,               'Enable',          'On'); 
set(handles.btnLoadJB,             'Enable',          'On'); 

set(handles.btnSaveJB,             'Enable',          'Off'); 
set(handles.btnTest1,              'Enable',          'Off'); 

set(handles.btnSwitchNums,         'Enable',          'Off');
set(handles.btnComputeAll1,        'Enable',          'Off');  
set(handles.btnStoreExchange1,     'Enable',          'Off');
set(handles.ckbJB1,                'Enable',          'Off'); 
set(handles.ckbJP1,                'Enable',          'Off'); 
set(handles.ckbJG1,                'Enable',          'Off'); 
set(handles.ckbXMark1,             'Enable',          'Off'); 
set(handles.ckbJBFile1,            'Enable',          'Off'); 
set(handles.ckbJPFile1,            'Enable',          'Off'); 
set(handles.ckbJGFile1,            'Enable',          'Off'); 
set(handles.ckbXMarkFile1,         'Enable',          'Off'); 
set(handles.ckbLiqCoreMask,        'Enable',          'Off');
set(handles.ckbComplement,         'Enable',          'Off');
set(handles.ckbStore,              'Enable',          'Off');
set(handles.edtAvgStart,           'Enable',          'Off');
set(handles.edtAvgEnd,             'Enable',          'Off');
set(handles.edtXOrigin,            'Enable',          'Off');
set(handles.edtSubtractionFrame,   'Enable',          'Off');
set(handles.ckbUseSubtractionFrame,'Enable',          'Off');
set(handles.ckbUseSubtractionFrameView,'Enable',      'Off');
set(handles.ckbSiebers,            'Enable',          'Off');

set(handles.ckbJB2,                'Enable',          'Off'); 
set(handles.ckbJP2,                'Enable',          'Off'); 
set(handles.ckbJG2,                'Enable',          'Off'); 
set(handles.ckbXMark2,             'Enable',          'Off'); 
set(handles.ckbJBFile2,            'Enable',          'Off'); 
set(handles.ckbJPFile2,            'Enable',          'Off'); 
set(handles.ckbJGFile2,            'Enable',          'Off'); 
set(handles.ckbXMarkFile2,         'Enable',          'Off'); 

set(handles.txtCurrentJetCenter,   'Enable',          'Off'); 
set(handles.edtJetCenter1,         'Enable',          'Off'); 
set(handles.btnMarker1,            'Enable',          'Off'); 
set(handles.edtPercentAdj1,        'Enable',          'Off'); 

set(handles.btnRefresh,            'Enable',          'Off'); 
set(handles.pumStrategy1,          'Enable',          'Off'); 

pumStrategy1_Callback(hObject, eventdata, handles)

set(handles.edtInput1_1,           'Enable',          'Off'); 
set(handles.edtInput1_2,           'Enable',          'Off'); 
set(handles.edtInput1_3,           'Enable',          'Off'); 
set(handles.edtInput1_4,           'Enable',          'Off'); 
set(handles.edtInput1_5,           'Enable',          'Off'); 
set(handles.edtInput1_6,           'Enable',          'Off'); 
set(handles.edtInput1_7,           'Enable',          'Off');  
set(handles.edtInput1_8,           'Enable',          'Off');  

set(handles.edtJBInput1_1,         'Enable',          'Off'); 
set(handles.edtJBInput1_2,         'Enable',          'Off');  
set(handles.edtJBInput1_3,         'Enable',          'Off');  
set(handles.edtJBInput1_4,         'Enable',          'Off');  
set(handles.edtJBInput1_5,         'Enable',          'Off');  
set(handles.edtJBInput1_6,         'Enable',          'Off');  
set(handles.edtJBInput1_7,         'Enable',          'Off');  
set(handles.edtJBInput1_8,         'Enable',          'Off');  

set(handles.btnJetPenetration,     'Enable',          'Off');  

% Results
set(handles.edtTime1,              'Enable',          'Off'); 
set(handles.edtJetAngle1,          'Enable',          'Off'); 
set(handles.edtJetPen1_mm,         'Enable',          'Off'); 
set(handles.edtJetPen1_pixels,     'Enable',          'Off'); 

set(handles.ckbJBFileSum,          'Enable',          'Off');  
set(handles.ckbJPFileSum,          'Enable',          'Off');  
set(handles.ckbJGFileSum,          'Enable',          'Off');  
set(handles.ckbJBSum,              'Enable',          'Off');  
set(handles.ckbJPSum,              'Enable',          'Off');  
set(handles.ckbJGSum,              'Enable',          'Off');  

set(handles.btnTransferInputs1,    'Enable',          'Off');  

set(handles.btnDeleteFile1,        'Enable',          'Off');  

set(handles.btnMinusJP1,           'Enable',          'Off');  
set(handles.btnPlusJP1,            'Enable',          'Off');  
set(handles.btnTestMarker1,        'Enable',          'Off');  
set(handles.ckbMarkerActive1,      'Enable',          'Off');  

set(handles.btnThresholdMinus1,    'Enable',          'Off');  
set(handles.btnThresholdPlus1,     'Enable',          'Off');  
set(handles.edtThresholdStep1,     'Enable',          'Off');  
set(handles.btnDilateMinus1,       'Enable',          'Off');  
set(handles.btnDilatePlus1,        'Enable',          'Off');  
set(handles.btnErodeMinus1,        'Enable',          'Off');  
set(handles.btnErodePlus1,         'Enable',          'Off');  

set(handles.edtComputeStart1,      'Enable',          'Off');  
set(handles.edtComputeEnd1,        'Enable',          'Off');  
set(handles.edtComputeStep1,       'Enable',          'Off');  
set(handles.btnDeleteMultiple1,    'Enable',          'Off');  
set(handles.edtDeleteStart1,       'Enable',          'Off');  
set(handles.edtDeleteEnd1,         'Enable',          'Off');  

set(handles.btnDelToEnd1,          'Enable',          'Off');  
set(handles.btnDelToStart1,        'Enable',          'Off');  

set(handles.edtJetCenterStore1,    'Enable',          'Off');  
set(handles.edtJetPenFracStore1,   'Enable',          'Off');  

set(handles.ckbLoadSameFrameNumbers,'Enable',          'Off');  
set(handles.edtThetaInput,          'Enable',          'Off');
set(handles.text137,                'Enable',          'Off');


filename = get(handles.edtFileName,    'String')                           %#ok<NOPRT>
pathname = get(handles.edtFileLocation,'String')                           %#ok<NOPRT>
%cineNamePath = filename                                                   %#ok<NOPRT>
cineNamePath = strrep(fullfile(pathname,filename),'.cine','')              %#ok<NOPRT>
startFrame = str2num(get(handles.edtStartFrame,   'String'));              %#ok<ST2NM>
totalFrames = str2num(get(handles.edtTotalFrames, 'String'));              %#ok<ST2NM>
FirstFrameNumber = str2num(get(handles.txtFirstImageNumber,'String'));     %#ok<ST2NM>


% For *.mat files only (not *.cin, or *.cine):
% [pathstr, name, ext, versn] = fileparts(filename);
[pathstr, name, ext] = fileparts(filename);
if strcmp(ext,'.mat')
    load([pathname filename])
end

% --- Validate frame numbers to be loaded ---
if strcmp(ext,'.mat')
    if totalFrames < 1;
        totalFrames = 1;
    set(handles.edtTotalFrames, 'String', totalFrames);
    end
    if startFrame > imageCount
        startFrame = imageCount;
    end
    if startFrame + totalFrames - 1 > imageCount
        totalFrames = imageCount - startFrame;
        set(handles.edtTotalFrames, 'String', totalFrames);
    end
    % Add these values so that the refreshCallback works correctly.
    offsetRead = 1; % 
    offsetWrite = 0;
else
    if startFrame > firstImageNumber + imageCount - 1;
    startFrame = firstImageNumber + imageCount - 1;
    set(handles.edtStartFrame, 'String', startFrame);
    end 
    if startFrame + totalFrames - 1 > firstImageNumber + imageCount - 1;
        totalFrames = firstImageNumber + imageCount - startFrame;
        set(handles.edtTotalFrames, 'String', totalFrames);
    end 
    if startFrame < firstImageNumber;
        startFrame = firstImageNumber;
        set(handles.edtStartFrame, 'String', startFrame);
    end
    % Offset to the frame number used for the cine read program, e.g., the
    % first frame of the cine textfile might be (-57) but it is the first (1)
    % frame in the cine file.
    offsetRead = (FirstFrameNumber*-1)+1;  

    % Offset to the frame number used for writing frames to the screen, e.g.,
    % the first image in the image array could be frame (-10).
    offsetWrite = (startFrame*-1)+1;               
end

if strcmp(ext,'.mat')
    % Images to process:
    endFrame = totalFrames;
    images = images(:,:,startFrame:endFrame);
else
    imdata=readcin90(cineNamePath, ...
        [startFrame + offsetRead,startFrame + totalFrames + offsetRead-1]);
    images = imdata.Images.RawImages;
end

%Note: if the movie is facing right to left, uncomment the following three
%lines:
%for i = 1:size(images,3)
%   images(:,:,i) = fliplr(images(:,:,i));
%end

if strcmp(ext,'.mat')
    % Already loaded in above
else
    imSize(1) = imdata.CameraSetup.ImWidth;
    imSize(2) = imdata.CameraSetup.ImHeight;
end
clear global imdata
%set(handles.figure1,'CurrentAxes',handles.axsOrigMovie)
axes(handles.axsOrigMovie)
CRng = str2num(get(handles.edtCRng,'String'));
handles.hImage = imshow(images(:,:,startFrame + offsetWrite),CRng,'XData',[0 imSize(1)],'YData',[0 imSize(2)]);
guidata(hObject, handles)
colormap(gray);
set(handles.edtCurrentFrame, 'String', startFrame);
currentFrame=startFrame;
Perimeter = zeros(size(images),'uint8');
JB = cell(imageCount,19);

% Sets the jet center at half the image height.... 
%   Takes account of different image sizes
set(handles.txtCurrentJetCenter, 'String', size(images,1)/2);
set(handles.edtJetCenter1, 'String', size(images,1)/2);




% Set time1 on gui
injStartFrame = str2num(get(handles.edtInjStartFrame,'String'));           %#ok<ST2NM>

% Get the image time (as related to the actual SOI signal) directly from 
%   the cine file header. This properly aligns the timebase with the images.

if strcmp(ext,'.mat')
    t1 = t1*1e6; % t1 was loaded in above (in seconds, this is in us)
    t2 = t1(currentFrame-startFrame+1);
else
    t1 = (imdata.TimeStamps.Data_Fractions-imdata.CineHeader.TriggerTime.fractions)*1e6-...
    (imdata.TimeStamps.Data_Fractions(injStartFrame+1)-imdata.TimeStamps.Data_Fractions(1))*1e6;
    t2 = t1(currentFrame-startFrame+1);
end
set(handles.edtTime1, 'String', num2str(t2,'%10.1f'));
set(handles.edtCurrentFileName, 'String', [pathname filename]);

% Set delete limits
set(handles.edtDeleteStart1, 'String', num2str(startFrame));
set(handles.edtDeleteEnd1, 'String', ...
    num2str(startFrame + totalFrames - 1));
% Set compute limits
set(handles.edtComputeStart1, 'String', num2str(startFrame));
set(handles.edtComputeEnd1, ...
    'String', num2str(startFrame + totalFrames - 1));
function btnLoadJB_Callback(hObject, eventdata, handles)
global JB %JB_mm%filename
%input_filename = [edtfilename(1:8),'.jb'];
%input_filename = [strrep(filename,'cine',''),'jb'];
%try
%    load('-mat',input_filename);
%catch exc                                                                  %#ok<NASGU>
[input_filename,pathName] = uigetfile('*.jb','Please browse for the appropriate JB file');
if isequal([input_filename,pathName],[0,0])
    return
end % User cancelled
jb_path = fullfile(pathName,input_filename);
jb_path_mm = [jb_path '_mm'];
clear JB JB_mm
load(jb_path,'-mat');
%load(jb_path_mm,'-mat');
%end
set(handles.ckbJB1, 'Value', 1); %set the JB checkbox in the GUI to on
set(handles.ckbJP1, 'Value', 1); %set the JB checkbox in the GUI to on
set(handles.ckbJB2, 'Value', 1); %set the JB checkbox in the GUI to on
set(handles.ckbJP2, 'Value', 1); %set the JB checkbox in the GUI to on

%currentFrame = str2bound(get(handles.edtCurrentFrame,'String'));
Scale = JB{1,14}(1,1);
injStartFrame = JB{1,14}(1,2);
startFrame = JB{1,14}(1,3);
totalFrames = JB{1,14}(1,4);

try % Newer JB files (newer than 2/26) should have these fields...
    xOrigin = JB{1,14}(1,6);
    yOrigin = JB{1,14}(1,7);
catch % For older JB files without the proper x and y origin saving...
    xOrigin = [];
    yOrigin = [];
    i = 1;
    while isempty(xOrigin) || isempty(yOrigin);
        try
        xOrigin = JB{i,4}(1,5);
        yOrigin = JB{i,4}(1,6);
        catch
        end
        i = i+1;
    end
end
set(handles.edtXOrigin,    'String', num2str(xOrigin))
set(handles.edtJetCenter1, 'String', num2str(yOrigin))

%txtFrameRate16 = JB{1,14}(1,5)

set(handles.edtScaleFile, 'String', Scale);
set(handles.edtInjStartFrame, 'String', injStartFrame);

if get(handles.ckbLoadSameFrameNumbers, 'Value') == 0
    btnLoadCine_Callback(hObject, eventdata, handles)
    clear JB
    load(jb_path,'-mat');
else    
    set(handles.edtStartFrame, 'String', startFrame);
    set(handles.edtTotalFrames, 'String', totalFrames);
    btnLoadCine_Callback(hObject, eventdata, handles)
    clear JB
    load(jb_path,'-mat');
end    
set(handles.edtsavePath,'String',jb_path)
handles.JBisAlreadySaved = 1;
guidata(hObject, handles)

%btnSave_Callback(hObject, eventdata, handles)
%btnScaleFile_Callback(hObject, eventdata, handles)
function btnSaveJB_Callback(hObject, eventdata, handles)
global JB startFrame totalFrames offsetRead offsetWrite Output filename t1 %#ok<NUSED>
switch iscaller
    case 'uiSaveJB_Callback_ClickedCallback'
        isCalledByToolbar = 1;
    otherwise 
        isCalledByToolbar = 0;
end

if handles.JBisAlreadySaved && isCalledByToolbar
    output_filename = get(handles.edtsavePath,'String');
    if isempty(output_filename) % Check to make sure a path was selected.
        return
    end
else
    %output_filename = [edtfilename(1:8),'.jb'];
    %savePath = get(handles.edtsavePath,'String')  
    if ~isempty(get(handles.edtsavePath,'String'))
        savedPath = get(handles.edtsavePath,'String');  
    else
    savedPath = get(handles.edtCurrentFileName,'String');
    end
%     [pathstr, name, ext, versn] = fileparts(savedPath);                         %#ok<NASGU>
    [pathstr, name, ext] = fileparts(savedPath);                         %#ok<NASGU>
    %suggestedPath = [strrep(savePath,'cine',''),'jb'];
    suggestedPath = fullfile(pathstr,[name '.jb']);
    [filename, pathname] = uiputfile( ...
        {'*.jb';'*.jbmm'}, ...
        'Save as', ...
        suggestedPath);
    output_filename = fullfile(pathname,filename);
    if isequal([filename,pathname],[0,0]) % Handle "Cancel" buttonpress
        %cd(initialdirectory);                     
        return     
    end
end

% Convert older JB files to have some of the data they need to properly
% store the x and y origins. For this to work the correct origin values
% must be in the corresponding text boxes!!!!!
try 
    JB{1,14}(1,6);
    JB{1,14}(1,7);
catch %#ok<*CTCH>
    JB{1,14}(1,6) = str2num(get(handles.edtXOrigin,'String'));
    JB{1,14}(1,7) = str2num(get(handles.edtJetCenter1,'String'));
end

numCellsJB = size(JB,1);
JB_mm = cell(numCellsJB,2);
Scale = str2num(get(handles.edtScaleFile,'String'));
for i=1:numCellsJB
    if ~isempty(JB{i,1})
        %JB_mm{i,2} = (JB{i,1}(:,1)-handles.c_L.y0) * JB{1,14}(1,1);
        %JB_mm{i,1} = (JB{i,1}(:,2)-handles.c_L.x0) * JB{1,14}(1,1);
        JB_mm{i,2} = (JB{i,1}(:,1)-JB{i,4}(1,6)) * Scale; %6 is y
        JB_mm{i,1} = (JB{i,1}(:,2)-JB{i,4}(1,5)) * Scale; %5 is x
        %JB{i,2}(1,4) = 3;  % A trick to change the size of strip ignored by injector to 3 (temporary!)
        %JB{i,4}(1,6) = 3;  % A trick to change the X origin to 3 (temporary!!)
        %JB{i,4}(1,11) = 1; % A trick to change the subtraction frame to 1 (temporary!!!)
    end
end
%output_filename = [savePath strrep(filename,'cine',''),'jb'];
%output_filename_mm = [savePath strrep(filename,'cine',''),'jbmm'];
timeV = [t1(1);t1];

output_filename_mm = [output_filename '_mm'];
save(output_filename,'JB','timeV');
save(output_filename_mm,'JB_mm','timeV');

set(handles.edtsavePath,'String',output_filename)
handles.JBisAlreadySaved = 1;

% ---- Save the *.geo file along with the JB file ----

if isempty(get(handles.edtsavePath,'String'))
savePath = get(handles.edtCurrentFileName,'String');
else
   savePath = get(handles.edtsavePath,'String'); 
end
% [pathstr, name, ext, versn] = fileparts(savePath);                         %#ok<NASGU>
[pathstr, name, ext] = fileparts(savePath);                         %#ok<NASGU>
%suggestedPath = [strrep(savePath,'cine',''),'geo'];
%suggestedPath = fullfile(pathstr,[name '.geo']);
saveFileName = fullfile(pathstr,[name '.geo']);

% This was the UI method which is now automatic
%[filename, pathname] = uiputfile( ...
%    {'*.geo'}, ...
%    'Save as', ...
%    suggestedPath);

%saveFileName = fullfile(pathname,filename);
%if isequal([filename,pathname],[0,0]) % Handle "Cancel" buttonpress
	%cd(initialdirectory);                     
    %return     
%end

% Choose Elements to save into *.geo file from the JB file
Scale            = str2num(get(handles.edtScaleFile,'String')); %#ok<ST2NM>
injStartFrame    = JB{1,14}(1,2);
firstFrameLoaded = JB{1,14}(1,3); %#ok<NASGU>
lastFrameLoaded  = JB{1,14}(1,4); %#ok<NASGU>
frameRate16      = JB{1,14}(1,5); %#ok<NASGU>


frame           = zeros(totalFrames,1);
framesFromStart = zeros(totalFrames,1);
timeFromSOI     = zeros(totalFrames,1);
sprayAngle      = zeros(totalFrames,1);
penDistPix      = zeros(totalFrames,1);
penDistmm       = zeros(totalFrames,1);
maxpenDistmm       = zeros(totalFrames,1);
for currentFrame=startFrame:startFrame+totalFrames - 1
    frame          (currentFrame + offsetWrite) = currentFrame;
    framesFromStart(currentFrame + offsetWrite) = currentFrame - injStartFrame;
    timeFromSOI    (currentFrame + offsetWrite) = t1(currentFrame-startFrame+1);
    if ~isempty(JB{currentFrame + offsetRead,4})
        sprayAngle(currentFrame + offsetWrite) = JB{currentFrame + offsetRead,4}(1,4); % penetration angle 
        penDistPix(currentFrame + offsetWrite) = JB{currentFrame + offsetRead,4}(1,2); % penetration distance (pixels)
        penDistmm (currentFrame + offsetWrite) = (JB{currentFrame + offsetRead,4}(1,2))* Scale; % penetration distance (mm)
        maxpenDistmm (currentFrame + offsetWrite)= max(JB{currentFrame + offsetRead,1}(:,1))* Scale; % max penetration distance (mm)
    end
end

save(saveFileName,'-mat','Scale','injStartFrame','firstFrameLoaded', ...
                         'frameRate16','frame','framesFromStart', ...
                         'timeFromSOI','sprayAngle','penDistPix', ...
                         'penDistmm','maxpenDistmm')
                     
                     
guidata(hObject, handles)

function ckbLoadSameFrameNumbers_Callback(hObject, eventdata, handles)
function edtStartFrame_Callback(hObject, eventdata, handles)
function edtTotalFrames_Callback(hObject, eventdata, handles)

% Load Subset of Cine Create Functions
function edtStartFrame_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtTotalFrames_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





% -------------------------------------------------------------------------
%                Set scale and unlock GUI controls
% -------------------------------------------------------------------------

% Scale and Unlock Callbacks
function btnSave_Callback(hObject, eventdata, handles)
global JB frameRate16 t1

startFrame    = str2double(get(handles.edtStartFrame,    'String'));
totalFrames   = str2double(get(handles.edtTotalFrames,   'String'));
Scale         = double(str2num(get(handles.edtScaleFile,     'String'))); %#ok<ST2NM>
injStartFrame = str2double(get(handles.edtInjStartFrame, 'String'));
JB{1,14} = zeros(1,5); % Reinitialize cell array (ugly)
JB{1,14}(1,1:5) = double([Scale injStartFrame startFrame totalFrames frameRate16]);

set(handles.btnSave,'Foregroundcolor','black');  

set(handles.btnUnlock,             'Enable',          'On');    
set(handles.btnSave,               'Enable',          'Off');   
set(handles.edtScaleFile,          'Enable',          'Off');  
set(handles.edtInjStartFrame,      'Enable',          'Off');  

set(handles.btnLoadJB,             'Enable',          'On');      
set(handles.btnTest1,              'Enable',          'On');  

set(handles.btnComputeAll1,        'Enable',          'On');   
set(handles.btnStoreExchange1,     'Enable',          'On');
set(handles.btnStoreExchange1,     'Enable',          'On');
set(handles.ckbJB1,                'Enable',          'On');  
set(handles.ckbJP1,                'Enable',          'On');  
set(handles.ckbJG1,                'Enable',          'On');  
set(handles.ckbXMark1,             'Enable',          'On');  
set(handles.ckbJBFile1,            'Enable',          'On');  
set(handles.ckbJPFile1,            'Enable',          'On');  
set(handles.ckbJGFile1,            'Enable',          'On');  
set(handles.ckbXMarkFile1,         'Enable',          'On');  
set(handles.btnSwitchNums,         'Enable',          'On');
set(handles.ckbLiqCoreMask,        'Enable',          'On');
set(handles.ckbComplement,         'Enable',          'On');
set(handles.ckbStore,              'Enable',          'On');
set(handles.edtAvgStart,           'Enable',          'On');
set(handles.edtAvgEnd,             'Enable',          'On');
set(handles.edtXOrigin,            'Enable',          'On');
if get(handles.ckbUseSubtractionFrame,'Value') ...
        || get(handles.ckbUseSubtractionFrameView,'Value')
    set(handles.edtSubtractionFrame,   'Enable',      'On');
end
set(handles.ckbUseSubtractionFrame,'Enable',          'On');
set(handles.ckbUseSubtractionFrameView,'Enable',         'On');
set(handles.ckbSiebers,            'Enable',          'On');

set(handles.ckbJB2,                'Enable',          'On');  
set(handles.ckbJP2,                'Enable',          'On');  
set(handles.ckbJG2,                'Enable',          'On');  
set(handles.ckbXMark2,             'Enable',          'On');  
set(handles.ckbJBFile2,            'Enable',          'On');  
set(handles.ckbJPFile2,            'Enable',          'On');  
set(handles.ckbJGFile2,            'Enable',          'On');  
set(handles.ckbXMarkFile2,         'Enable',          'On');  

set(handles.txtCurrentJetCenter,   'Enable',          'On');  
set(handles.edtJetCenter1,         'Enable',          'On');  
set(handles.btnMarker1,            'Enable',          'On');  
set(handles.edtPercentAdj1,        'Enable',          'On');  

set(handles.btnRefresh,            'Enable',          'On');  
set(handles.pumStrategy1,          'Enable',          'On');  
pumStrategy1_Callback(hObject, eventdata, handles)



set(handles.edtInput1_1,           'Enable',          'On');  
set(handles.edtInput1_2,           'Enable',          'On');  
set(handles.edtInput1_3,           'Enable',          'On');  
set(handles.edtInput1_4,           'Enable',          'On');  
set(handles.edtInput1_5,           'Enable',          'On');  
set(handles.edtInput1_6,           'Enable',          'On');  
set(handles.edtInput1_7,           'Enable',          'On');  
set(handles.edtInput1_8,           'Enable',          'On');  

set(handles.edtJBInput1_1,         'Enable',          'On');  
set(handles.edtJBInput1_2,         'Enable',          'On');  
set(handles.edtJBInput1_3,         'Enable',          'On');  
set(handles.edtJBInput1_4,         'Enable',          'On');  
set(handles.edtJBInput1_5,         'Enable',          'On');  
set(handles.edtJBInput1_6,         'Enable',          'On');  
set(handles.edtJBInput1_7,         'Enable',          'On');  
set(handles.edtJBInput1_8,         'Enable',          'On');  

set(handles.btnJetPenetration,     'Enable',          'On');  

set(handles.edtTime1,              'Enable',          'On');  
set(handles.edtJetAngle1,          'Enable',          'On');  
set(handles.edtJetPen1_mm,         'Enable',          'On');  
set(handles.edtJetPen1_pixels,     'Enable',          'On');  

set(handles.ckbJBFileSum,          'Enable',          'On');  
set(handles.ckbJPFileSum,          'Enable',          'On');  
set(handles.ckbJGFileSum,          'Enable',          'On');  
set(handles.ckbJBSum,              'Enable',          'On');  
set(handles.ckbJPSum,              'Enable',          'On');  
set(handles.ckbJGSum,              'Enable',          'On');  

set(handles.btnTransferInputs1,    'Enable',          'On');  

set(handles.btnDeleteFile1,        'Enable',          'On');  

set(handles.btnMinusJP1,           'Enable',          'On');  
set(handles.btnPlusJP1,            'Enable',          'On');  
set(handles.btnTestMarker1,        'Enable',          'On');  
set(handles.ckbMarkerActive1,      'Enable',          'On');  

set(handles.btnThresholdMinus1,    'Enable',          'On');  
set(handles.btnThresholdPlus1,     'Enable',          'On');  
set(handles.edtThresholdStep1,     'Enable',          'On');  
set(handles.btnDilateMinus1,       'Enable',          'On');  
set(handles.btnDilatePlus1,        'Enable',          'On');  
set(handles.btnErodeMinus1,        'Enable',          'On');  
set(handles.btnErodePlus1,         'Enable',          'On');  

set(handles.edtComputeStart1,      'Enable',          'On');  
set(handles.edtComputeEnd1,        'Enable',          'On');  
set(handles.edtComputeStep1,       'Enable',          'On');  
set(handles.btnDeleteMultiple1,    'Enable',          'On');  
set(handles.edtDeleteStart1,       'Enable',          'On');  
set(handles.edtDeleteEnd1,         'Enable',          'On');  

set(handles.btnDelToEnd1,          'Enable',          'On');  
set(handles.btnDelToStart1,        'Enable',          'On');  

set(handles.edtJetCenterStore1,    'Enable',          'On');  
set(handles.edtJetPenFracStore1,   'Enable',          'On');  

set(handles.ckbLoadSameFrameNumbers,'Enable',          'On'); 
set(handles.edtThetaInput,          'Enable',          'On');
set(handles.text137,                'Enable',          'On');
currentFrame = str2num(get(handles.edtCurrentFrame,'String')); 
t2 = t1(currentFrame-startFrame+1); 
set(handles.edtTime1, 'String', num2str(t2,'%10.1f'));

function btnUnlock_Callback(hObject, eventdata, handles)

set(handles.btnSave,               'Foregroundcolor', 'red');  
set(handles.btnSave,               'Enable',          'On');    
set(handles.btnUnlock,             'Enable',          'Off');   
set(handles.edtScaleFile,          'Enable',          'On');  
set(handles.edtInjStartFrame,      'Enable',          'On');   

set(handles.btnLoadJB,             'Enable',          'Off');      
set(handles.btnSaveJB,             'Enable',          'Off');  
set(handles.btnTest1,              'Enable',          'Off');  

set(handles.btnComputeAll1,        'Enable',          'Off');   
set(handles.btnStoreExchange1,     'Enable',          'Off');
set(handles.ckbJB1,                'Enable',          'Off');  
set(handles.ckbJP1,                'Enable',          'Off');  
set(handles.ckbJG1,                'Enable',          'Off');  
set(handles.ckbXMark1,             'Enable',          'Off');  
set(handles.ckbJBFile1,            'Enable',          'Off');  
set(handles.ckbJPFile1,            'Enable',          'Off');  
set(handles.ckbJGFile1,            'Enable',          'Off');  
set(handles.ckbXMarkFile1,         'Enable',          'Off'); 
set(handles.btnSwitchNums,         'Enable',          'Off');
set(handles.ckbLiqCoreMask,        'Enable',          'Off');
set(handles.ckbComplement,         'Enable',          'Off');
set(handles.ckbStore,              'Enable',          'Off');
set(handles.edtAvgStart,           'Enable',          'Off');
set(handles.edtAvgEnd,             'Enable',          'Off');
set(handles.edtXOrigin,            'Enable',          'Off');
set(handles.edtSubtractionFrame,   'Enable',          'Off');
set(handles.ckbUseSubtractionFrame,'Enable',          'Off');
set(handles.ckbUseSubtractionFrameView,'Enable',      'Off');
set(handles.ckbSiebers,            'Enable',          'Off');

set(handles.ckbJB2,                'Enable',          'Off');  
set(handles.ckbJP2,                'Enable',          'Off');  
set(handles.ckbJG2,                'Enable',          'Off');  
set(handles.ckbXMark2,             'Enable',          'Off');  
set(handles.ckbJBFile2,            'Enable',          'Off');  
set(handles.ckbJPFile2,            'Enable',          'Off');  
set(handles.ckbJGFile2,            'Enable',          'Off');  
set(handles.ckbXMarkFile2,         'Enable',          'Off');  

set(handles.txtCurrentJetCenter,   'Enable',          'Off');  
set(handles.edtJetCenter1,         'Enable',          'Off');  
set(handles.btnMarker1,            'Enable',          'Off');  
set(handles.edtPercentAdj1,        'Enable',          'Off');  

set(handles.btnRefresh,            'Enable',          'Off');  
set(handles.pumStrategy1,          'Enable',          'Off');  
pumStrategy1_Callback(hObject, eventdata, handles)



set(handles.edtInput1_1,           'Enable',          'Off');  
set(handles.edtInput1_2,           'Enable',          'Off');  
set(handles.edtInput1_3,           'Enable',          'Off');  
set(handles.edtInput1_4,           'Enable',          'Off');  
set(handles.edtInput1_5,           'Enable',          'Off');  
set(handles.edtInput1_6,           'Enable',          'Off');  
set(handles.edtInput1_7,           'Enable',          'Off');  
set(handles.edtInput1_8,           'Enable',          'Off');  

set(handles.edtJBInput1_1,         'Enable',          'Off');  
set(handles.edtJBInput1_2,         'Enable',          'Off');  
set(handles.edtJBInput1_3,         'Enable',          'Off');  
set(handles.edtJBInput1_4,         'Enable',          'Off');  
set(handles.edtJBInput1_5,         'Enable',          'Off');  
set(handles.edtJBInput1_6,         'Enable',          'Off');  
set(handles.edtJBInput1_7,         'Enable',          'Off');  
set(handles.edtJBInput1_8,         'Enable',          'Off');  

set(handles.btnJetPenetration,     'Enable',          'Off');  

set(handles.edtTime1,              'Enable',          'Off');  
set(handles.edtJetAngle1,          'Enable',          'Off');  
set(handles.edtJetPen1_mm,         'Enable',          'Off');  
set(handles.edtJetPen1_pixels,     'Enable',          'Off');  

set(handles.ckbJBFileSum,          'Enable',          'Off');  
set(handles.ckbJPFileSum,          'Enable',          'Off');  
set(handles.ckbJGFileSum,          'Enable',          'Off');  
set(handles.ckbJBSum,              'Enable',          'Off');  
set(handles.ckbJPSum,              'Enable',          'Off');  
set(handles.ckbJGSum,              'Enable',          'Off');   

set(handles.btnTransferInputs1,    'Enable',          'Off');  

set(handles.btnDeleteFile1,        'Enable',          'Off');  

set(handles.btnMinusJP1,           'Enable',          'Off');  
set(handles.btnPlusJP1,            'Enable',          'Off');  
set(handles.btnTestMarker1,        'Enable',          'Off');  
set(handles.ckbMarkerActive1,      'Enable',          'Off');  

set(handles.btnThresholdMinus1,    'Enable',          'Off');  
set(handles.btnThresholdPlus1,     'Enable',          'Off');  
set(handles.edtThresholdStep1,     'Enable',          'Off');  
set(handles.btnDilateMinus1,       'Enable',          'Off');  
set(handles.btnDilatePlus1,        'Enable',          'Off');  
set(handles.btnErodeMinus1,        'Enable',          'Off');  
set(handles.btnErodePlus1,         'Enable',          'Off');  

set(handles.ckbLoadSameFrameNumbers,'Enable',          'Off');  

set(handles.edtComputeStart1,      'Enable',          'Off');  
set(handles.edtComputeEnd1,        'Enable',          'Off');  
set(handles.edtComputeStep1,       'Enable',          'Off');  
set(handles.btnDeleteMultiple1,    'Enable',          'Off');  
set(handles.edtDeleteStart1,       'Enable',          'Off');  
set(handles.edtDeleteEnd1,         'Enable',          'Off');  

set(handles.btnDelToEnd1,          'Enable',          'Off');  
set(handles.btnDelToStart1,        'Enable',          'Off');  

set(handles.edtJetCenterStore1,    'Enable',          'Off');  
set(handles.edtJetPenFracStore1,   'Enable',          'Off');  

set(handles.ckbLoadSameFrameNumbers,'Enable',          'Off'); 
set(handles.edtThetaInput,          'Enable',          'Off');
set(handles.text137,                'Enable',          'Off');
function edtInjStartFrame_Callback(hObject, eventdata, handles)
function edtScaleFile_Callback(hObject, eventdata, handles)
function rdbStop_Callback(hObject, eventdata, handles)

% Scale and Unlock Create Functions
function edtInjStartFrame_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtScaleFile_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





% -------------------------------------------------------------------------
%                      Frame Navigation Tools
% -------------------------------------------------------------------------

% Frame Navigation Callbacks
function btnLoop_Callback(hObject, eventdata, handles)
global startFrame totalFrames currentFrame  

% Get the loop step size
StepSize = str2double(get(handles.edtStepSize,'String'));

% Turn off the stop on the radio button
set(handles.rdbStop,'Value',0);
pause(0.1) % Allow time for radio button setting to register

OrigCurrentFrame = currentFrame;
while get(handles.rdbStop,'Value')==0   %continue until stop requested
    for currentFrame=OrigCurrentFrame:StepSize:totalFrames + startFrame - 1
        btnRefresh_Callback(hObject, eventdata, handles)  
        if get(handles.rdbStop,'Value')==1; 
            return %stop requested
        end
    end
    for currentFrame=startFrame:StepSize:OrigCurrentFrame - 1
                btnRefresh_Callback(hObject, eventdata, handles)  
        if get(handles.rdbStop,'Value')==1; 
            return %stop requested
        end
    end  
end 
function btnNextFrame_Callback(hObject, eventdata, handles)
global currentFrame startFrame totalFrames

StepSize = str2double(get(handles.edtStepSize,'String'));
currentFrame = currentFrame + StepSize; %Advance currentFrame by Step
%If exceeds last image then wrap to start
if currentFrame > totalFrames + startFrame - 1; 
%    edtCurrentFrame = edtStartFrame + edtTotalFrames - 1;
     currentFrame = startFrame; 
end

btnRefresh_Callback(hObject, eventdata, handles)
function btnPreviousFrame_Callback(hObject, eventdata, handles)
global currentFrame startFrame totalFrames

StepSize = str2double(get(handles.edtStepSize,'String'));
currentFrame = currentFrame-StepSize; %Decrease frame number
if currentFrame < startFrame; %If past first frame then wrap to last frame
%    edtCurrentFrame = edtStartFrame; 
    currentFrame = totalFrames + startFrame - 1;
end
btnRefresh_Callback(hObject, eventdata, handles)
function edtCurrentFrame_Callback(hObject, eventdata, handles)
global startFrame totalFrames currentFrame 
currentFrame = str2num(get(handles.edtCurrentFrame,'String'));             %#ok<ST2NM>

if currentFrame < startFrame; 
    currentFrame = startFrame; 
    set(handles.edtCurrentFrame, 'String', currentFrame);
elseif currentFrame > totalFrames + startFrame - 1; 
    currentFrame = totalFrames + startFrame - 1;
    set(handles.edtCurrentFrame, 'String', currentFrame);
end

btnRefresh_Callback(hObject, eventdata, handles)
function edtStepSize_Callback(hObject, eventdata, handles)

% Frame Navigation Create Functions
function edtCurrentFrame_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtStepSize_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end









% -------------------------------------------------------------------------
%                          Jet Marker Store
% -------------------------------------------------------------------------

% Jet Marker1 Store Callbacks
function edtJetCenterStore1_Callback(hObject, eventdata, handles)
function edtJetCenterStore2_Callback(hObject, eventdata, handles)
function edtJetPenFracStore1_Callback(hObject, eventdata, handles)
function edtJetPenFracStore2_Callback(hObject, eventdata, handles)

% Jet Marker1 Store Create Functions
function edtJetCenterStore1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJetCenterStore2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJetPenFracStore1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJetPenFracStore2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% -------------------------------------------------------------------------
%                     File and Display Options
% -------------------------------------------------------------------------

function ckbJB1_Callback(hObject, eventdata, handles)
btnRefresh_Callback(hObject, eventdata, handles)
function ckbJB2_Callback(hObject, eventdata, handles)
btnRefresh_Callback(hObject, eventdata, handles)
function ckbJG1_Callback(hObject, eventdata, handles)
btnRefresh_Callback(hObject, eventdata, handles)
function ckbJG2_Callback(hObject, eventdata, handles)
btnRefresh_Callback(hObject, eventdata, handles)
function ckbJP1_Callback(hObject, eventdata, handles)
btnRefresh_Callback(hObject, eventdata, handles)
function ckbJP2_Callback(hObject, eventdata, handles)
btnRefresh_Callback(hObject, eventdata, handles)
function ckbJBFile1_Callback(hObject, eventdata, handles)
function ckbJBFile2_Callback(hObject, eventdata, handles)
function ckbJBFileSum_Callback(hObject, eventdata, handles)
function ckbJGFile1_Callback(hObject, eventdata, handles)
function ckbJGFile2_Callback(hObject, eventdata, handles)
function ckbJGFileSum_Callback(hObject, eventdata, handles)
function ckbJPFile1_Callback(hObject, eventdata, handles)
function ckbJPFile2_Callback(hObject, eventdata, handles)
function ckbJPFileSum_Callback(hObject, eventdata, handles)
function ckbJBSum_Callback(hObject, eventdata, handles)
btnRefresh_Callback(hObject, eventdata, handles)
function ckbJGSum_Callback(hObject, eventdata, handles)
btnRefresh_Callback(hObject, eventdata, handles)
function ckbJPSum_Callback(hObject, eventdata, handles)
btnRefresh_Callback(hObject, eventdata, handles)
function ckbXMark1_Callback(hObject, eventdata, handles)
btnRefresh_Callback(hObject, eventdata, handles)
function ckbXMark2_Callback(hObject, eventdata, handles)
btnRefresh_Callback(hObject, eventdata, handles)
function ckbXMarkFile1_Callback(hObject, eventdata, handles)
function ckbXMarkFile2_Callback(hObject, eventdata, handles)
function edtsavePath_Callback(hObject, eventdata, handles)

% File and Display Options Create Functions
function edtsavePath_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtCRng_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% -------------------------------------------------------------------------
%            Boundary Analysis and Penetration Calculation (1)
% -------------------------------------------------------------------------

% Boundary Analysis and Penetration Calculation (1) Callbacks
function btnComputeAll1_Callback(hObject, eventdata, handles)
global currentFrame 
ComputeStart = str2double(get(handles.edtComputeStart1, 'String'));
ComputeEnd   = str2double(get(handles.edtComputeEnd1,   'String'));
ComputeStep  = str2double(get(handles.edtComputeStep1,  'String'));

set(handles.rdbStop,'Value',0)
for currentFrame = ComputeStart:ComputeStep:ComputeEnd
    if get(handles.ckbTransferAllInputsFromJB,'Value')
        % Transfers inputs before each call to test from JB. Useful trick!
        btnTransferInputs1_Callback(hObject, eventdata, handles)
        
        % USEFUL NOTE:
        % Did you forget to set the jet center correctly (or any other
        % inputs?) Just set it here, (uncomment the following code),
        % click transfer all inputs during compute between and forget it!
        % Just don't forget to recomment when you're done.
        
        % set(handles.edtJetCenter1,'String',num2str(203))
        % set(handles.edtScaleFile,'String',num2str(0.12255))
    end
    btnTest1_Callback(hObject, eventdata, handles)
    drawnow % Added to synchronize drawing events 12/18/09 RKG
    set(handles.edtCurrentFrame,'String',num2str(currentFrame)) 
    if get(handles.rdbStop,'Value') == 1
        return
    end
end 
function btnDilateMinus1_Callback(hObject, eventdata, handles)
DilateLevel = str2double(get(handles.edtInput1_5,'String'));
DilateLevel = DilateLevel - 1;
if DilateLevel < 0; DilateLevel = 0; end
set(handles.edtInput1_5,'String',num2str(DilateLevel));
btnTest1_Callback(hObject, eventdata, handles)
function btnDilatePlus1_Callback(hObject, eventdata, handles)
DilateLevel = str2double(get(handles.edtInput1_5,'String'));
DilateLevel = DilateLevel + 1;
set(handles.edtInput1_5,'String',num2str(DilateLevel));
btnTest1_Callback(hObject, eventdata, handles)
function btnErodeMinus1_Callback(hObject, eventdata, handles)
ErodeLevel = str2double(get(handles.edtInput1_4,'String'));
ErodeLevel = ErodeLevel - 1;
if ErodeLevel < 0; ErodeLevel = 0; end
set(handles.edtInput1_4,'String',num2str(ErodeLevel));
btnTest1_Callback(hObject, eventdata, handles)
function btnErodePlus1_Callback(hObject, eventdata, handles)
ErodeLevel = str2double(get(handles.edtInput1_4,'String'));
ErodeLevel = ErodeLevel + 1;
set(handles.edtInput1_4,'String',num2str(ErodeLevel));
btnTest1_Callback(hObject, eventdata, handles)
function btnSwitchNums_Callback(hObject, eventdata, handles)
% Updates the 'compute all' boxes as you go... cheap trick...
computeStart1 = str2double(get(handles.edtComputeStart1,'String'));
computeEnd1   = str2double(get(handles.edtComputeEnd1,  'String'));
totalFrames = str2double(get(handles.edtTotalFrames,'String'));
%startFrame = str2double(get(handles.edtStartFrame,'String'));
if totalFrames <= computeEnd1+1
    newComputeStart = totalFrames;
else
    newComputeStart = computeEnd1+1;
end
jumpFrames = 20;
if totalFrames <= computeEnd1+jumpFrames
    newComputeEnd = totalFrames;
else
    newComputeEnd = computeEnd1+21;
end
set(handles.edtComputeStart1,'String',num2str(newComputeStart))
set(handles.edtComputeEnd1,  'String',num2str(newComputeEnd))
function btnTest1_Callback(hObject, eventdata, handles)

global images offsetWrite offsetRead startFrame currentFrame JB frameRate16  
global Orifice Density InjPress TestImage1 boundary t1
global x y dist jetCenter dimIm   

% Show the user that changes have been made to the JB structure which can now be saved 
set(handles.btnSaveJB, 'Enable', 'On'); 
% Change the save icon to blue (from gray)
load file_save.mat % Contains blue save icon data
set(findobj('-regexp','tag','uiSaveJB'),'CData',icon)     

% Enable GUI boundary and file checkboxes
set(handles.ckbJB1,     'Value', 1); 
set(handles.ckbJBFile1, 'Value', 1); 
set(handles.ckbJP1,     'Value', 1); 
set(handles.ckbJPFile1, 'Value', 1); 

% Get popup menu selection
val = get(handles.pumStrategy1,'Value'); %number position in popup menu 1 
string_list = get(handles.pumStrategy1,'String'); %items in popup menu 1
JOB = string_list{val}; % Actual item selected in popup menu 1

%Get subtraction frame number
% :TEST for Viewing vs Calculating:
%subtractbool = get(handles.ckbUseSubtractionFrame,'Value');
if get(handles.ckbUseSubtractionFrame,'Value')
    subtractbool = 1; %1 = calculate
    if get(handles.ckbUseSubtractionFrameView,'Value')
        subtractbool = 3; % 3 = calculate AND view
    end
elseif get(handles.ckbUseSubtractionFrameView,'Value')
    subtractbool = 2; %2 = view
else subtractbool = 0; %0 = don't use
end

    
if subtractbool %if using subtraction frame in some way
    subframe = get(handles.edtSubtractionFrame,'String');
    try subframe = round(str2double(subframe)); %if str2double doesn't work
    catch %set subtractionFrame to startFrame
        set(handles.edtSubtractionFrame,'String',startFrame);
        subframe = startFrame;
    end
    if subframe == currentFrame %If subfram is current frame, subframe should be the startframe
        subframe = startFrame;
    end
    if currentFrame == startFrame
        return
    end
    if subframe <= -1 %use negative value to use previous frame
        if currentFrame > startFrame 
        subframe = currentFrame-1; %use previous frame
        else %if currentframe is startframe, there is no previous frame to use
            return
        end
    end
end

% Get the current image
TestImage1=images(:,:,currentFrame + offsetWrite);
Input1 = str2double(get(handles.edtInput1_1,'String'));
Input2 = str2double(get(handles.edtInput1_2,'String'));
Input3 = str2double(get(handles.edtInput1_3,'String'));
Input4 = str2double(get(handles.edtInput1_4,'String'));
Input5 = str2double(get(handles.edtInput1_5,'String'));
Input6 = str2double(get(handles.edtInput1_6,'String'));
Input7 = str2double(get(handles.edtInput1_7,'String'));
Input8 = str2double(get(handles.edtInput1_8,'String'));
x_c =    str2double(get(handles.edtXOrigin, 'String'));
injStartFrame = str2double(get(handles.edtInjStartFrame,'String'));
Scale = str2num(get(handles.edtScaleFile,'String')); %#ok<ST2NM> %JB{1,14}(1,1);
jetCenter = str2double(get(handles.edtJetCenter1,   'String'));
PercentAdj = str2double(get(handles.edtPercentAdj1,'String'));
time = t1(currentFrame - startFrame + 1);  %time after injection first starts
dist = jetPenCalculation(Orifice*1000,Density,700,InjPress,time/1000)/Scale * PercentAdj; % dist into chamber x adjustment factor
JB{currentFrame + offsetRead,1}=[];
JB{currentFrame + offsetRead,2}=[];
JB{currentFrame + offsetRead,3}=[];
JB{currentFrame + offsetRead,4}=[]; 
JB{currentFrame + offsetRead,5}=[];
JB{currentFrame + offsetRead,11}=[];
JB{currentFrame + offsetRead,12}=[];
JB{currentFrame + offsetRead,13}=[]; 


% Mask out large spreading angle near injector LMP 2/4/2009
% Make mask to block out regions not of interest tan(theta/2) of 0.3 
% Edited RKG 8/31/09 to reflect actual calculated y-origin (though x not
% automatic and currently has no box in GUI to change it.
xOrigin = x_c;                                                               % UPDATE THIS LATER!!!
yOrigin = str2double(get(handles.edtJetCenter1,  'String'));
dimIm = size(TestImage1);
%t2=0.3; % tangent(theta/2) tangent of half angle of mask
t2=0.4; % wider angle for bklda (RKG 4/28/10)
xpolym = [xOrigin-10 yOrigin/t2 dimIm(2) dimIm(2) (dimIm(1)-yOrigin)/t2]; 
ypolym = [yOrigin 0 0 dimIm(1) dimIm(1)];
mask = roipoly(dimIm(1),dimIm(2),xpolym,ypolym); % Region of interest polygon
% Find out if the user wants to mask the liquid core
liqCoreMask = get(handles.ckbLiqCoreMask,'Value');
complement = get(handles.ckbComplement,'Value');
if subtractbool == 3 || subtractbool == 1 %use subtraction frame to calculate
   %subtract given image from current
   TestImage1 = TestImage1 - images(:,:,subframe+offsetWrite) + 2000; 
end
if subtractbool == 2 %use subtraction frame to view
   %subtract given image from current
   TmpTestImage1 = TestImage1 - images(:,:,subframe+offsetWrite)+2000;
end
switch JOB;
    case '(1) Texture (stdv)'
         % Calculate  and plot the 'X marks the spot' location for this Frame
        if get(handles.ckbMarkerActive1,'Value')==1
            XMark = dist; YMark = jetCenter;
            set(handles.ckbXMarkFile1,'Value',1); %%enable the X Mark checkbox file on the GUI
        else 
            XMark = []; YMark = [];
        end    
        [x,y,maxJ,minJ]=JBtexture(TestImage1,1,Input1,Input2,Input3, ...
            Input4,Input5, Input6, Input7, Input8, XMark, YMark, mask, ...
            liqCoreMask, x_c, complement);
        
        JB{currentFrame + offsetRead,1} = [x y];
        JB{currentFrame + offsetRead,2} = [currentFrame val Input1 Input2 Input3 Input4 Input5 Input6 Input7 Input8 jetCenter PercentAdj];
        JB{currentFrame + offsetRead,5} = [XMark YMark maxJ minJ];
        
        % Plot boundary over underlying image
        set(handles.ckbJB1, 'Value', 1); %set the JB checkbox in the GUI to on
        set(handles.edtJBInput1_1, 'String', Input1); %Update the analysis settings to the screen...
        set(handles.edtJBInput1_2, 'String', Input2);
        set(handles.edtJBInput1_3, 'String', Input3);
        set(handles.edtJBInput1_4, 'String', Input4);
        set(handles.edtJBInput1_5, 'String', Input5);
        set(handles.edtJBInput1_6, 'String', Input6);
        set(handles.edtJBInput1_7, 'String', Input7);
        set(handles.edtJBInput1_8, 'String', Input8);
        set(handles.txtCurrentPercentAdj, 'String', PercentAdj);
        set(handles.txtMethod1, 'String', JOB);
        boundary = 1;
        btnJetPenetration_Callback(hObject, eventdata, handles)
        if subtractbool == 2
           TestImage1 = TmpTestImage1; 
        end
        % Update the GUI plots
        udpateGUIPlots(hObject, handles)
    case '(2) TextureDIFF (stdv)' % User selects TextureDIFF (stdv)
        if currentFrame == startFrame; 
            disp('currentFrame == startFrame!')
            return
        end
        TestImage2=images(:,:, currentFrame + offsetWrite - 1);
        if get(handles.ckbMarkerActive1,'Value')==1
            XMark = dist; 
            YMark = jetCenter;
            
            % Enable the X Mark checkbox file on the GUI
            set(handles.ckbXMarkFile1,'Value',1); 
        else 
            XMark = []; YMark = [];
        end    
        [x,y]=JBtextureDIFF(TestImage1,TestImage2, 1,Input1,Input2, ...
            Input3,Input4,Input5, Input6, Input7, Input8, XMark, YMark, ...
            mask, liqCoreMask, x_c, complement);
        JB{currentFrame + offsetRead,1} = [x y];
        JB{currentFrame + offsetRead,2} = [currentFrame val Input1 Input2 Input3 Input4 Input5 Input6 Input7 Input8 jetCenter PercentAdj];
        JB{currentFrame + offsetRead,5} = [XMark YMark];
        set(handles.ckbJB1, 'Value', 1); %set the JB checkbox in the GUI to on
        set(handles.edtJBInput1_1, 'String', Input1); %Update the analysis settings to the screen...
        set(handles.edtJBInput1_2, 'String', Input2);
        set(handles.edtJBInput1_3, 'String', Input3);
        set(handles.edtJBInput1_4, 'String', Input4);
        set(handles.edtJBInput1_5, 'String', Input5);
        set(handles.edtJBInput1_6, 'String', Input6);
        set(handles.edtJBInput1_7, 'String', Input7);
        set(handles.edtJBInput1_8, 'String', Input8);
        set(handles.txtCurrentPercentAdj, 'String', PercentAdj);
        set(handles.txtMethod1, 'String', JOB);
        boundary = 1;
        btnJetPenetration_Callback(hObject, eventdata, handles)
        if subtractbool == 2
           TestImage1 = TmpTestImage1; 
        end
        % Update the GUI plots
        udpateGUIPlots(hObject, handles)
        
    case '(4) stdev wrt time' % User selects stdev wrt time routine
        %'(4) stdev wrt time' routine needs the previous two image frames
        if currentFrame < startFrame + 2; 
            return; 
        end  
        if get(handles.ckbMarkerActive1,'Value')==1
            XMark = dist; 
            YMark = jetCenter;
            
            % Enable the X Mark checkbox file on the GUI
            set(handles.ckbXMarkFile1,'Value',1); 
        else 
            XMark = []; YMark = [];
        end    
        TestImage2=images(:,:,currentFrame + offsetWrite - 1);
        TestImage3=images(:,:,currentFrame + offsetWrite - 2);
        [x,y]=JBtime_stdev(TestImage1,TestImage2, TestImage3,1,Input1, ...
            Input2,Input3,Input4,Input5, Input6, Input7, Input8, XMark, ...
            YMark, jetCenter, liqCoreMask, x_c, complement, mask);
        
        JB{currentFrame + offsetRead,1} = [x y];
        JB{currentFrame + offsetRead,2} = [currentFrame val Input1 Input2 Input3 Input4 Input5 Input6 Input7 Input8 jetCenter PercentAdj];
        
        set(handles.ckbJB1, 'Value', 1); %set the JB checkbox in the GUI to on
        set(handles.edtJBInput1_1, 'String', Input1); %Update the analysis settings to the screen...
        set(handles.edtJBInput1_2, 'String', Input2);
        set(handles.edtJBInput1_3, 'String', Input3);
        set(handles.edtJBInput1_4, 'String', Input4);
        set(handles.edtJBInput1_5, 'String', Input5);
        set(handles.edtJBInput1_6, 'String', Input6);
        set(handles.edtJBInput1_7, 'String', Input7);
        set(handles.edtJBInput1_8, 'String', Input8);
        set(handles.txtCurrentPercentAdj, 'String', PercentAdj);
        set(handles.txtMethod1, 'String', JOB);
        boundary = 1;
        btnJetPenetration_Callback(hObject, eventdata, handles)
        if subtractbool == 2
           TestImage1 = TmpTestImage1; 
        end
        % Update the GUI plots
        udpateGUIPlots(hObject, handles)
        
               
        %{
        % plot center line
        hold on; 
        line([1 512],[jetCenter jetCenter], ...
        'Color','y','LineWidth',2);
        hold off;  
        %}

    case '(3) Threshold' % User selects Threshold
        % Calculate the 'X marks the spot' location for this Frame 
        set(handles.ckbMarkerActive1,'Value',1);
        if get(handles.ckbMarkerActive1,'Value')==1
            XMark = dist; YMark = jetCenter;
            set(handles.ckbXMarkFile1,'Value',1); %%enable the X Mark checkbox file on the GUI
        else 
            XMark = []; YMark = []; jetCenter=[]; 
        end    
        [x,y]=JBthreshold(TestImage1,1,complement, Input2,Input3,Input4, ...
            Input5, Input6, Input7, Input8, XMark, YMark, liqCoreMask, ...
            x_c, mask);
        JB{currentFrame + offsetRead,1} = [x y];
        JB{currentFrame + offsetRead,2} = [currentFrame val Input1 Input2 Input3 Input4 Input5 Input6 Input7 Input8 jetCenter PercentAdj];
        JB{currentFrame + offsetRead,5} = [XMark YMark];
        
        % Plot boundary over underlying image
        set(handles.ckbJB1, 'Value', 1); %set the JB checkbox in the GUI to on
        set(handles.edtJBInput1_1, 'String', Input1); %Update the analysis settings to the screen...
        set(handles.edtJBInput1_2, 'String', Input2);
        set(handles.edtJBInput1_3, 'String', Input3);
        set(handles.edtJBInput1_4, 'String', Input4);
        set(handles.edtJBInput1_5, 'String', Input5);
        set(handles.edtJBInput1_6, 'String', Input6);
        set(handles.edtJBInput1_7, 'String', Input7);
        set(handles.edtJBInput1_8, 'String', Input8);
        set(handles.txtCurrentPercentAdj, 'String', PercentAdj);
        set(handles.txtMethod1, 'String', JOB);
        boundary = 1; 
        btnJetPenetration_Callback(hObject, eventdata, handles)
        if subtractbool == 2
           TestImage1 = TmpTestImage1; 
        end
        % Update the GUI plots
        udpateGUIPlots(hObject, handles)
        
    case '(5) aviV' % User selects aviV routine
        % aviV needs a previous image to work.
        if currentFrame == startFrame; 
            disp('currentFrame == startFrame!')
            return
        end
        TestImage2=images(:,:, currentFrame + offsetWrite - 1);
        
        % Get Input 1 (X coordinate of origin)
        Input1 = str2double(get(handles.edtXOrigin,'String'));
        set(handles.edtInput1_1,'String',num2str(Input1))
                
        % Calculate  and plot the 'X marks the spot' location for this Frame
        if get(handles.ckbMarkerActive1,'Value')==1
            XMark = dist; YMark = jetCenter;
            % Enable the X Mark checkbox file on the GUI
            set(handles.ckbXMarkFile1,'Value',1); 
            
        else 
            XMark = []; YMark = [];
        end    
        
        [x,y,maxJ,minJ]=JBaviV(TestImage1,TestImage2, ...
            1,Input1,Input2,Input3,Input4,Input5, Input6, Input7, ...
            Input8, XMark, YMark, mask, liqCoreMask, complement);
        
        
        JB{currentFrame + offsetRead,1} = [x y];
        JB{currentFrame + offsetRead,2} =  ...
            [currentFrame val Input1 Input2 Input3 Input4 Input5 Input6 ...
            Input7 Input8 jetCenter PercentAdj];
        JB{currentFrame + offsetRead,5} = [XMark YMark maxJ minJ];
        
        set(handles.ckbJB1, 'Value', 1); %set the JB checkbox in the GUI to on
        set(handles.edtJBInput1_1, 'String', Input1); %Update the analysis settings to the screen...
        set(handles.edtJBInput1_2, 'String', Input2);
        set(handles.edtJBInput1_3, 'String', Input3);
        set(handles.edtJBInput1_4, 'String', Input4);
        set(handles.edtJBInput1_5, 'String', Input5);
        set(handles.edtJBInput1_6, 'String', Input6);
        set(handles.edtJBInput1_7, 'String', Input7);
        set(handles.edtJBInput1_8, 'String', Input8);
        set(handles.txtCurrentPercentAdj, 'String', PercentAdj);
        set(handles.txtMethod1, 'String', JOB);
        boundary = 1;
        btnJetPenetration_Callback(hObject, eventdata, handles)
        if subtractbool == 2
           TestImage1 = TmpTestImage1; 
        end
        % Update the GUI plots
        udpateGUIPlots(hObject, handles)
end
function btnThresholdMinus1_Callback(hObject, eventdata, handles)
ThresholdStep = str2double(get(handles.edtThresholdStep1,'String'));
ThresholdLevel = str2double(get(handles.edtInput1_3,'String'));
ThresholdLevel = ThresholdLevel - ThresholdStep;
if ThresholdLevel < 0; ThresholdLevel = 0; end
set(handles.edtInput1_3,'String',num2str(ThresholdLevel));
btnTest1_Callback(hObject, eventdata, handles)
function btnThresholdPlus1_Callback(hObject, eventdata, handles)
ThresholdStep = str2double(get(handles.edtThresholdStep1,'String'));
ThresholdLevel = str2double(get(handles.edtInput1_3,'String'));
ThresholdLevel = ThresholdLevel + ThresholdStep;
set(handles.edtInput1_3,'String',num2str(ThresholdLevel));

btnTest1_Callback(hObject, eventdata, handles)
function ckbComplement_Callback(hObject, eventdata, handles)
btnTest1_Callback(hObject, eventdata, handles)
function ckbLiqCoreMask_Callback(hObject, eventdata, handles)
btnTest1_Callback(hObject, eventdata, handles)
function edtComputeStart1_Callback(hObject, eventdata, handles)
global startFrame 

ComputeStart = str2double(get(handles.edtComputeStart1,'String'));
ComputeEnd = str2double(get(handles.edtComputeEnd1,'String'));

if ComputeStart < startFrame; 
    ComputeStart = startFrame; 
    set(handles.edtComputeStart1, 'String', ComputeStart);
end
if ComputeStart > ComputeEnd
    ComputeStart = ComputeEnd;
    set(handles.edtComputeStart1, 'String', ComputeStart);
end
function edtComputeStep1_Callback(hObject, eventdata, handles)
function edtComputeEnd1_Callback(hObject, eventdata, handles)
global startFrame totalFrames

ComputeStart = str2double(get(handles.edtComputeStart1,'String'));
ComputeEnd = str2double(get(handles.edtComputeEnd1,'String'));

if ComputeEnd > startFrame + totalFrames - 1; 
    ComputeEnd = startFrame + totalFrames - 1;  
    set(handles.edtComputeEnd1, 'String', ComputeEnd);
end
if ComputeEnd < ComputeStart
    ComputeEnd = ComputeStart;
    set(handles.edtComputeEnd1, 'String', ComputeEnd);
end
function edtCRng_Callback(hObject, eventdata, handles)
function edtInput1_1_Callback(hObject, eventdata, handles)
btnTest1_Callback(hObject, eventdata, handles)
function edtInput1_2_Callback(hObject, eventdata, handles)
btnTest1_Callback(hObject, eventdata, handles)
function edtInput1_3_Callback(hObject, eventdata, handles)
btnTest1_Callback(hObject, eventdata, handles)
function edtInput1_4_Callback(hObject, eventdata, handles)
btnTest1_Callback(hObject, eventdata, handles)
function edtInput1_5_Callback(hObject, eventdata, handles)
btnTest1_Callback(hObject, eventdata, handles)
function edtInput1_6_Callback(hObject, eventdata, handles)
btnTest1_Callback(hObject, eventdata, handles)
function edtInput1_7_Callback(hObject, eventdata, handles)
function edtInput1_8_Callback(hObject, eventdata, handles)
function edtSubtractionFrame_Callback(hObject, eventdata, handles)
function edtThresholdStep1_Callback(hObject, eventdata, handles)
function pumStrategy1_Callback(hObject, eventdata, handles)
global images currentFrame offsetWrite

% Image Size
height = size(images,1);
length = size(images,2);

% Number position in popup menu 1 
val = get(handles.pumStrategy1,'Value'); 

% Items in popup menu 1
string_list = get(handles.pumStrategy1,'String'); 

% Actual item selected in popup menu 1
Strategy = string_list{val}; 

% Run code by strategy
switch Strategy;
    case '(1) Texture (stdv)'
        set(handles.InputText1,  'String', 'Size of stdev filter in pixels (odd #)');
        set(handles.edtInput1_1, 'String', '5');
        set(handles.InputText2,  'String', 'Size of ignored strip by injector (pixels)');
        set(handles.edtInput1_2, 'String', '3');
        set(handles.InputText3,  'String', 'Threshold Value');
        set(handles.edtInput1_3, 'String', '90');
        set(handles.InputText4,  'String', 'Number of erodes');
        set(handles.edtInput1_4, 'String', '1');
        set(handles.InputText5,  'String', 'Number of dilates');
        set(handles.edtInput1_5, 'String', '0');
        set(handles.InputText6,  'String', 'Downstream Region Ignored');
        set(handles.edtInput1_6, 'String', num2str(length));
        set(handles.InputText7,  'String', 'Top Strip Ignored');
        set(handles.edtInput1_7, 'String', '1');
        set(handles.InputText8,  'String', 'Bottom Strip Ignored');
        set(handles.edtInput1_8, 'String', '1'); % num2str(height));
        set(handles.edtThresholdStep1, 'String', '10');
        set(handles.ckbMarkerActive1,         'Enable',          'On');  
    case '(2) TextureDIFF (stdv)'
        set(handles.InputText1,  'String', 'Size of stdev filter in pixels (odd #)');
        set(handles.edtInput1_1, 'String', '5');
        set(handles.InputText2,  'String', 'Size of ignored strip by injector (pixels)');
        set(handles.edtInput1_2, 'String', '3');
        set(handles.InputText3,  'String', 'Threshold Value');
        set(handles.edtInput1_3, 'String', '50');
        set(handles.InputText4,  'String', 'Number of erodes');
        set(handles.edtInput1_4, 'String', '0');
        set(handles.InputText5,  'String', 'Number of dilates');
        set(handles.edtInput1_5, 'String', '0');
        set(handles.InputText6,  'String', 'Downstream Region Ignored');
        set(handles.edtInput1_6, 'String', num2str(length));
        set(handles.InputText7,  'String', 'Top Strip Ignored');
        set(handles.edtInput1_7, 'String', '1');
        set(handles.InputText8,  'String', 'Bottom Strip Ignored');
        set(handles.edtInput1_8, 'String', '1') %num2str(height));
        set(handles.edtThresholdStep1, 'String', '10');
        set(handles.ckbMarkerActive1,         'Enable',          'On');  
    case '(4) stdev wrt time' 
        set(handles.InputText1,  'String', 'Size of stdev filter in pixels (odd number)');
        set(handles.edtInput1_1, 'String', '5');
        set(handles.InputText2,  'String', 'Size of ignored strip by injector (pixels)');
        set(handles.edtInput1_2, 'String', '3');
        set(handles.InputText3,  'String', 'Threshold Value');
        set(handles.edtInput1_3, 'String', '15');
        set(handles.InputText4,  'String', 'Number of erodes');
        set(handles.edtInput1_4, 'String', '0');
        set(handles.InputText5,  'String', 'Number of dilates');
        set(handles.edtInput1_5, 'String', '0');  
        set(handles.InputText6,  'String', 'Downstream Region Ignored');
        set(handles.edtInput1_6, 'String', num2str(length));
        set(handles.InputText7,  'String', 'Top Strip Ignored');
        set(handles.edtInput1_7, 'String', '1');
        set(handles.InputText8,  'String', 'Bottom Strip Ignored');
        set(handles.edtInput1_8, 'String', '1'); %num2str(height));
        set(handles.edtThresholdStep1, 'String', '10');
        set(handles.ckbMarkerActive1,         'Enable',          'Off');  
    case '(3) Threshold'
        set(handles.InputText1,  'String', 'Complement Image? (Yes = 1, No = 0)');
        set(handles.edtInput1_1, 'String', '1');
        set(handles.InputText2,  'String', 'Size of ignored strip by injector (pixels)');
        set(handles.edtInput1_2, 'String', '3');
        set(handles.InputText3,  'String', 'Threshold Value');
        set(handles.edtInput1_3, 'String', '0.75');
        set(handles.InputText4,  'String', 'Number of erodes');
        set(handles.edtInput1_4, 'String', '0');
        set(handles.InputText5,  'String', 'Number of dilates');
        set(handles.edtInput1_5, 'String', '0');
        set(handles.InputText6,  'String', 'Downstream Region Ignored');
        set(handles.edtInput1_6, 'String', num2str(length));
        set(handles.InputText7,  'String', 'Top Strip Ignored');
        set(handles.edtInput1_7, 'String', '0');
        set(handles.InputText8,  'String', 'Bottom Strip Ignored');
        set(handles.edtInput1_8, 'String', '1') %num2str(height));
        set(handles.edtThresholdStep1, 'String', '0.01');
        set(handles.ckbMarkerActive1,         'Enable',          'On');  
    case '(5) aviV'
        edtInput1_1 = get(handles.edtXOrigin,  'String');
        set(handles.InputText1,  'String', 'X-origin (set by edtXOrigin on left)');
        set(handles.edtInput1_1, 'String', edtInput1_1);
        set(handles.InputText2,  'String', 'Size of ignored strip by injector (pixels)');
        set(handles.edtInput1_2, 'String', '3');
        set(handles.InputText3,  'String', 'Threshold Value');
        set(handles.edtInput1_3, 'String', '0.20');
        set(handles.InputText4,  'String', 'Number of erodes');
        set(handles.edtInput1_4, 'String', '0');
        set(handles.InputText5,  'String', 'Number of dilates');
        set(handles.edtInput1_5, 'String', '0');
        set(handles.InputText6,  'String', 'Downstream Region Ignored');
        set(handles.edtInput1_6, 'String', num2str(length));
        set(handles.InputText7,  'String', 'Top Strip Ignored');
        set(handles.edtInput1_7, 'String', '1');
        set(handles.InputText8,  'String', 'Bottom Strip Ignored');
        set(handles.edtInput1_8, 'String', '1'); %num2str(height));
        set(handles.edtThresholdStep1, 'String', '0.01');
        set(handles.ckbMarkerActive1,         'Enable',          'On');  
end







% Boundary Analysis and Penetration Calculation (1) Create Functions
function edtComputeEnd1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtComputeStart1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtComputeStep1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtInput1_1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtInput1_2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtInput1_3_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtInput1_4_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtInput1_5_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtInput1_6_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtInput1_7_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtInput1_8_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtSubtractionFrame_CreateFcn(hObject, eventdata, handles)

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtThresholdStep1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function pumStrategy1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
 %   set(hObject,'String',{'(1) Texture (stdv)','Memne','Sinc'});
 %   set(hObject,'Value',1);
end





% -------------------------------------------------------------------------
%                        Current Inputs (1)
% -------------------------------------------------------------------------

% Current Inputs (1) Callbacks
function btnStoreExchange1_Callback(hObject, eventdata, handles)
global JB imageCount startFrame totalFrames offsetRead
Store = cell(imageCount,5);

for currentFrame=startFrame:startFrame+totalFrames - 1   

Store{currentFrame + offsetRead,1} = JB{currentFrame + offsetRead,1};
Store{currentFrame + offsetRead,2} = JB{currentFrame + offsetRead,2};
Store{currentFrame + offsetRead,3} = JB{currentFrame + offsetRead,3};
Store{currentFrame + offsetRead,4} = JB{currentFrame + offsetRead,4};
Store{currentFrame + offsetRead,5} = JB{currentFrame + offsetRead,5};

JB{currentFrame + offsetRead,1} = JB{currentFrame + offsetRead,15};
JB{currentFrame + offsetRead,2} = JB{currentFrame + offsetRead,16};
JB{currentFrame + offsetRead,3} = JB{currentFrame + offsetRead,17};
JB{currentFrame + offsetRead,4} = JB{currentFrame + offsetRead,18};
JB{currentFrame + offsetRead,5} = JB{currentFrame + offsetRead,19};

JB{currentFrame + offsetRead,15} = Store{currentFrame + offsetRead,1};
JB{currentFrame + offsetRead,16} = Store{currentFrame + offsetRead,2};
JB{currentFrame + offsetRead,17} = Store{currentFrame + offsetRead,3};
JB{currentFrame + offsetRead,18} = Store{currentFrame + offsetRead,4};
JB{currentFrame + offsetRead,19} = Store{currentFrame + offsetRead,5};

end

btnRefresh_Callback(hObject, eventdata, handles)
function btnTransferInputs1_Callback(hObject, eventdata, handles)
global offsetRead currentFrame JB 
if isempty(JB{currentFrame + offsetRead,1})==0; 

value = JB{currentFrame + offsetRead,2}(1,2); %number position in popup menu 1 from JB file 
set(handles.pumStrategy1,'Value',value)
pumStrategy1_Callback(hObject, eventdata, handles)

set(handles.edtInput1_1, 'String', JB{currentFrame + offsetRead,2}(1,3)); %Update the analysis settings to the screen...
set(handles.edtInput1_2, 'String', JB{currentFrame + offsetRead,2}(1,4));
set(handles.edtInput1_3, 'String', JB{currentFrame + offsetRead,2}(1,5));
set(handles.edtInput1_4, 'String', JB{currentFrame + offsetRead,2}(1,6));
set(handles.edtInput1_5, 'String', JB{currentFrame + offsetRead,2}(1,7));
set(handles.edtInput1_6, 'String', JB{currentFrame + offsetRead,2}(1,8));
set(handles.edtInput1_7, 'String', JB{currentFrame + offsetRead,2}(1,9));
set(handles.edtInput1_8, 'String', JB{currentFrame + offsetRead,2}(1,10));
set(handles.edtXOrigin,  'String', JB{currentFrame + offsetRead,4}(1,6));
set(handles.edtAvgStart, 'String', JB{currentFrame + offsetRead,4}(1,7));
set(handles.edtAvgEnd,   'String', JB{currentFrame + offsetRead,4}(1,8));
set(handles.ckbLiqCoreMask,'Value',JB{currentFrame + offsetRead,4}(1,9));
set(handles.ckbComplement, 'Value',JB{currentFrame + offsetRead,4}(1,10));
try
    % Data files as of 9/22/10 can handle these ones
    set(handles.edtSubtractionFrame,'String',JB{currentFrame + offsetRead,4}(1,11));
    set(handles.ckbUseSubtractionFrame,'Value',JB{currentFrame + offsetRead,4}(1,12));
    set(handles.ckbSiebers,'Value',JB{currentFrame + offsetRead,4}(1,13));
    set(handles.edtThetaInput,'String',num2str(JB{currentFrame + offsetRead,4}(1,14)));
catch %#ok<CTCH>
    disp('Could not transfer a theta input value because none existed in the JB file')
end
end
function edtJBInput1_1_Callback(hObject, eventdata, handles)
function edtJBInput1_2_Callback(hObject, eventdata, handles)
function edtJBInput1_3_Callback(hObject, eventdata, handles)
function edtJBInput1_4_Callback(hObject, eventdata, handles)
function edtJBInput1_5_Callback(hObject, eventdata, handles)
function edtJBInput1_6_Callback(hObject, eventdata, handles)
function edtJBInput1_7_Callback(hObject, eventdata, handles)
function edtJBInput1_8_Callback(hObject, eventdata, handles)

% Current Inputs (1) Create Functions
function edtJBInput1_1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJBInput1_2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJBInput1_3_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJBInput1_4_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJBInput1_5_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJBInput1_6_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJBInput1_7_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJBInput1_8_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% -------------------------------------------------------------------------
%                            Results
% -------------------------------------------------------------------------

% Results Callbacks
function edtJetAngle1_Callback(hObject, eventdata, handles)
function edtJetAngle2_Callback(hObject, eventdata, handles)
function edtJetAngleMerge_Callback(hObject, eventdata, handles)
function edtJetPen1_mm_Callback(hObject, eventdata, handles)
function edtJetPen1_pixels_Callback(hObject, eventdata, handles)
function edtJetPen2_mm_Callback(hObject, eventdata, handles)
function edtJetPen2_pixels_Callback(hObject, eventdata, handles)
function edtJetPenMerge_mm_Callback(hObject, eventdata, handles)
function edtJetPenMerge_pixels_Callback(hObject, eventdata, handles)
function edtTime1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtTime2_Callback(hObject, eventdata, handles)
function edtTimeMerge_Callback(hObject, eventdata, handles)

% Results Create Functions
function edtJetAngle1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJetAngle2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJetAngleMerge_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJetPen1_mm_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJetPen1_pixels_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJetPen2_mm_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJetPen2_pixels_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJetPenMerge_mm_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJetPenMerge_pixels_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtTime2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtTimeMerge_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end





% -------------------------------------------------------------------------
%                             Jet Marker (1)
% -------------------------------------------------------------------------

% Jet Marker (1) Callbacks

function btnMarker1_Callback(hObject, eventdata, handles)
global currentFrame startFrame totalFrames offsetWrite Density  ...
    InjPress Orifice images frameRate16 t1 TestImage1

injStartFrame = str2double(get(handles.edtInjStartFrame,'String'));
PercentAdj = str2double(get(handles.edtPercentAdj1,'String'));
jetCenter = str2double(get(handles.edtJetCenter1,'String'));

for currentFrame=startFrame:startFrame+totalFrames - 1

    time = t1(currentFrame-startFrame+1); %time after injection first starts
    dist = JetPenCalculation(Orifice*1000,Density,700,InjPress,time/1000) * PercentAdj; %dist into chamber x adjustment factor
    set(handles.edtCurrentFrame, 'String', currentFrame); %update gui with next current frame number
%   JB{edtCurrentFrame + offsetRead,5} = [dist edtJetCenter1]; %btnsave in cell array
    axes(handles.axsOrigMovie);                                               %#ok<*LAXES>
     %Display new current jet image
    CRng = str2num(get(handles.edtCRng,'String'));
    handles.hImage = imshow(images(:,:,currentFrame + offsetWrite),CRng,'XData',[0 size(TestImage1,2)],'YData',[0 size(TestImage1,1)]);
    guidata(hObject, handles)
    
	
    % X marks the spot
    hold on
    plot(round(dist),jetCenter, ...
        'yx', ...
        'MarkerSize',25, ...
        'LineWidth',3, ...
        'MarkerEdgeColor','r')
    hold off;  
        
end
function ckbMarkerActive1_Callback(hObject, eventdata, handles)
if get(handles.ckbMarkerActive1,'Value')==1;
    set(handles.ckbXMark1,'Value', 1);
    
else
    set(handles.ckbXMark1,'Value', 0);
   
end
btnRefresh_Callback(hObject, eventdata, handles)
function btnMinusJP1_Callback(hObject, eventdata, handles)
PercentAdj = str2double(get(handles.edtPercentAdj1,'String'));
PercentAdj = PercentAdj - 0.02;
set(handles.edtPercentAdj1,'String',num2str(PercentAdj));
if PercentAdj < 0.1; set(handles.edtPercentAdj1,'String',0.1); end
btnTestMarker1_Callback(hObject, eventdata, handles)

function btnPlusJP1_Callback(hObject, eventdata, handles)
PercentAdj = str2double(get(handles.edtPercentAdj1,'String'));
PercentAdj = PercentAdj + 0.02;
set(handles.edtPercentAdj1,'String',num2str(PercentAdj));
btnTestMarker1_Callback(hObject, eventdata, handles)

function btnTestMarker1_Callback(hObject, eventdata, handles)

global currentFrame startFrame offsetWrite Density InjPress Orifice images  ...
    frameRate16 t1 TestImage1 JB

injStartFrame = str2double(get(handles.edtInjStartFrame,'String'));
PercentAdj = str2double(get(handles.edtPercentAdj1,'String'));
jetCenter = str2double(get(handles.edtJetCenter1,'String'));
Scale = str2num(get(handles.edtScaleFile,'String'));%#ok<ST2NM> %JB{1,14}(1,1);

    time = t1(currentFrame-startFrame+1); %time after injection first starts
    dist = jetPenCalculation(Orifice*1000,Density,700,InjPress,time/1000) * PercentAdj; %dist into chamber x adjustment factor
    set(handles.edtCurrentFrame, 'String', currentFrame); %update gui with next current frame number
%   JB{edtCurrentFrame + offsetRead,5} = [dist edtJetCenter1]; %btnsave in cell array
    %set(handles.figure1,'CurrentAxes',handles.axsOrigMovie)
    axes(handles.axsOrigMovie); 
     %Display new current jet image
    CRng = str2num(get(handles.edtCRng,'String'));
    handles.hImage = imshow(images(:,:,currentFrame + offsetWrite),CRng,'XData',[0 size(TestImage1,2)],'YData',[0 size(TestImage1,1)]);
    guidata(hObject, handles)
    hold on; 
    plot(round(dist)/Scale,jetCenter, ...
        'yx', ...
        'MarkerSize',25, ...
        'LineWidth',3,...
        'MarkerEdgeColor','r'); 
    hold off;
function edtJetCenter1_Callback(hObject, eventdata, handles)
function edtPercentAdj1_Callback(hObject, eventdata, handles)
PercentAdj = str2double(get(handles.edtPercentAdj1,'String'));
%if edtPercentAdj1 > 1; set(handles.edtPercentAdj1,'String',1.0); end
if PercentAdj < 0.1; set(handles.edtPercentAdj1,'String',0.1); end
btnTestMarker1_Callback(hObject, eventdata, handles)
function edtTime1_Callback(hObject, eventdata, handles)

% Jet Marker (1) Create Functions
function edtJetCenter1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtPercentAdj1_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function ckbStore_Callback(hObject, eventdata, handles)






% -------------------------------------------------------------------------
%                             Delete (1)
% -------------------------------------------------------------------------

% Delete (1) Callbacks
function btnDeleteFile1_Callback(hObject, eventdata, handles)
global  offsetRead currentFrame JB 
    
JB{currentFrame + offsetRead,1}=[];
JB{currentFrame + offsetRead,2}=[];
JB{currentFrame + offsetRead,3}=[];
JB{currentFrame + offsetRead,4}=[]; 
JB{currentFrame + offsetRead,5}=[];
JB{currentFrame + offsetRead,11}=[];
JB{currentFrame + offsetRead,12}=[];
JB{currentFrame + offsetRead,13}=[]; 
btnRefresh_Callback(hObject, eventdata, handles)
function btnDeleteMultiple1_Callback(hObject, eventdata, handles)
global offsetRead currentFrame JB 

ArchiveCurrentFrame = currentFrame;
DeleteStart = str2double(get(handles.edtDeleteStart1,'String'));
DeleteEnd = str2double(get(handles.edtDeleteEnd1,'String'));

for currentFrame=DeleteStart:DeleteEnd
    JB{currentFrame + offsetRead,1}=[];
    JB{currentFrame + offsetRead,2}=[];
    JB{currentFrame + offsetRead,3}=[];
    JB{currentFrame + offsetRead,4}=[]; 
    JB{currentFrame + offsetRead,5}=[];
    JB{currentFrame + offsetRead,11}=[];
    JB{currentFrame + offsetRead,12}=[];
    JB{currentFrame + offsetRead,13}=[];  
end 
currentFrame = ArchiveCurrentFrame;
btnRefresh_Callback(hObject, eventdata, handles)
function btnDelToEnd1_Callback(hObject, eventdata, handles)
global offsetRead currentFrame totalFrames startFrame JB 
ArchiveCurrentFrame = currentFrame;
for currentFrame=currentFrame:startFrame + totalFrames - 1; 
    JB{currentFrame + offsetRead,1}=[];
    JB{currentFrame + offsetRead,2}=[];
    JB{currentFrame + offsetRead,3}=[];
    JB{currentFrame + offsetRead,4}=[]; 
    JB{currentFrame + offsetRead,5}=[];
    JB{currentFrame + offsetRead,11}=[];
    JB{currentFrame + offsetRead,12}=[];
    JB{currentFrame + offsetRead,13}=[];  
end 
currentFrame = ArchiveCurrentFrame;
btnRefresh_Callback(hObject, eventdata, handles)
function btnDelToStart1_Callback(hObject, eventdata, handles)
global offsetRead currentFrame startFrame JB 
ArchiveCurrentFrame = currentFrame;
for currentFrame=startFrame:currentFrame; 
    JB{currentFrame + offsetRead,1}=[];
    JB{currentFrame + offsetRead,2}=[];
    JB{currentFrame + offsetRead,3}=[];
    JB{currentFrame + offsetRead,4}=[]; 
    JB{currentFrame + offsetRead,5}=[];
    JB{currentFrame + offsetRead,11}=[];
    JB{currentFrame + offsetRead,12}=[];
    JB{currentFrame + offsetRead,13}=[];  
end 
currentFrame = ArchiveCurrentFrame;
btnRefresh_Callback(hObject, eventdata, handles)
function edtDeleteEnd1_Callback(hObject, eventdata, handles)
global startFrame totalFrames 

DeleteStart = str2double(get(handles.edtDeleteStart1,'String'));
DeleteEnd = str2double(get(handles.edtDeleteEnd1,'String'));

if DeleteEnd > startFrame + totalFrames - 1; 
    DeleteEnd = startFrame + totalFrames - 1; 
    set(handles.edtDeleteEnd1, 'String', DeleteEnd);
end
if DeleteEnd < DeleteStart
    DeleteStart = DeleteEnd; 
    set(handles.edtDeleteStart1, 'String', DeleteStart);
end
function edtDeleteStart1_Callback(hObject, eventdata, handles)
global startFrame 

DeleteStart = str2double(get(handles.edtDeleteStart1,'String'));
DeleteEnd = str2double(get(handles.edtDeleteEnd1,'String'));

if DeleteStart < startFrame; 
    DeleteStart = startFrame; 
    set(handles.edtDeleteStart1, 'String', DeleteStart);
end
if DeleteStart > DeleteEnd
    DeleteEnd = DeleteStart;
    set(handles.edtDeleteEnd1, 'String', DeleteEnd);
end

% Delete (2) Create Functions
function edtDeleteEnd1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtDeleteStart1_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% -------------------------------------------------------------------------
%                       Jet Penetration and Angle
% -------------------------------------------------------------------------

function btnJetPenetration_Callback(hObject, eventdata, handles)
global images JB currentFrame offsetWrite offsetRead boundary

jetCenter = str2double(get(handles.edtJetCenter1,'String'));
ImageSize = size(images(:,:,currentFrame + offsetWrite));

% Check to see if JetBoundary cell array is empty. If not (i.e. ==0) 
% then cell contains boundary data that needs plotting
if boundary == 1
    %Update the analysis settings to the screen...
    if isempty(JB{currentFrame + offsetRead,1})==0; 
         set(handles.edtJBInput1_1, 'String', ...
             JB{currentFrame + offsetRead,2}(1,3)); 
         set(handles.edtJBInput1_2, 'String', ...
             JB{currentFrame + offsetRead,2}(1,4));
         set(handles.edtJBInput1_3, 'String', ...
             JB{currentFrame + offsetRead,2}(1,5));
         set(handles.edtJBInput1_4, 'String', ...
             JB{currentFrame + offsetRead,2}(1,6));
         set(handles.edtJBInput1_5, 'String', ...
             JB{currentFrame + offsetRead,2}(1,7));
         set(handles.edtJBInput1_6, 'String', ...
             JB{currentFrame + offsetRead,2}(1,8));
         set(handles.edtJBInput1_7, 'String', ...
             JB{currentFrame + offsetRead,2}(1,9));
         set(handles.edtJBInput1_8, 'String', ...
             JB{currentFrame + offsetRead,2}(1,10));
         set(handles.btnJetPenetration, 'Enable', 'On'); 
         
         % Number position in pumStrategy1 from JB file 
         val = JB{currentFrame + offsetRead,2}(1,2); 
         
         % Items in pumStrategy1
         string_list = get(handles.pumStrategy1,'String'); 
         
         % Actual item selected in pumStrategy1
         JOB = string_list{val}; 
         set(handles.txtMethod1, 'String', JOB);

         % x and y locations of boundary
         x = JB{currentFrame + offsetRead,1}(:,1);   
         y = JB{currentFrame + offsetRead,1}(:,2);
         
         % Create a blank image
         bwimg = false(ImageSize);                                         

         % Fill the blank image with the boundary
         for i = 1:size(x)
             bwimg(y(i),x(i)) = 1;                                       
         end
        
         % Fill boundary
         bwimg = imfill(bwimg,'holes');
         
              
%         [FileStart, FileEnd, hfull, JetPen, hhalf, theta] = ...
%             JetPenetration(x, y, ImageSize, jetCenter);
         [c_L,S,theta,A_p,theta_l] = measureSpray(bwimg,hObject,handles);  
         
         % Somewhat match up outputs of this function with Tim's
         % JetPenetration Output. Set unused functions to NaN
         hfull = NaN;
         JetPen = S.SPix;
         hhalf = NaN;
         theta = theta.theta;
         jetCenter = [c_L.x0 c_L.y0];
         
         % Add additional info to the general geometry which saves per frame
         avgStart = str2double(get(handles.edtAvgStart,'String'));
         avgEnd = str2double(get(handles.edtAvgEnd,'String'));
         %xOrigin = str2double(get(handles.edtXOrigin,'String'));
         liqCoreMask = get(handles.ckbLiqCoreMask,'Value');
         complement = get(handles.ckbComplement,'Value');
         subtractionFrame = get(handles.edtSubtractionFrame,'String');
         subtractCalc = get(handles.ckbUseSubtractionFrame,'Value');
         Siebers = get(handles.ckbSiebers,'Value');
         thetaInput = str2double(get(handles.edtThetaInput,'String'));
         if isempty(subtractionFrame)
             subtractionFrame = [];
         else
             subtractionFrame = str2double(subtractionFrame);
         end
         % Check to see if a penetration length was found if so save data 
         if ~isempty(JetPen) 
            JB{currentFrame + offsetRead,3} = [x y]; %save jet boundary in cell array
            JB{currentFrame + offsetRead,4} = [hfull JetPen hhalf theta ...
                jetCenter avgStart avgEnd liqCoreMask complement ...
                subtractionFrame subtractCalc Siebers thetaInput]; % save geometry in cell array, 
                % keep in mind length(jetCenter)=2, so length(JB{:,4}=11)
                % at least for now...
         else
            JB{currentFrame + offsetRead,3} = []; %no jet boundary found, so clear any previous data
            JB{currentFrame + offsetRead,4} = []; %no geometry found, so clear any previous data 
         end
         %btnRefresh_Callback(hObject, eventdata, handles)
    end
end
%figure(1),plot(theta_l)

function edtXOrigin_Callback(hObject, eventdata, handles)
btnTest1_Callback(hObject, eventdata, handles)
function edtAvgStart_Callback(hObject, eventdata, handles)
function edtAvgEnd_Callback(hObject, eventdata, handles)

% Jet Penetration and Angle Create Functions
function edtXOrigin_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtAvgStart_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtAvgEnd_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Spray Measurement Function
function [c_L,S,theta,A_p,theta_l] = measureSpray(img,hObject,handles)
% Spray Measurements
    
% Reference:
%   Siebers, D. L., "Effects of Gas Density and Vaporization on
%   Penetration and Dispersion of Diesel Sprays," SAE Paper 960034,
%   1996.

% Centroid Position (cenPos) - Spray centroid position
% Spray Axis (c_L) - The line from the injector tip through the
%   centroid of the spray region.
% Penetration Distance (S) - The distance along the spray axis to a
%   location where 1/2 of the pixels on an arc of theta/2 centered on 
%   the spray axis are dark.
% Full Cone Angle (theta) - theta = arctan((A_p,S/2)/(S/2)^2), where
%   (A_p,S/2) is the projected spray area of the upstream half of the
%   spray in an image.
% Projected Area (A_p) - Projected area of the spray
% "Local" Spray Dispersion Angle (theta_l(x)) - theta_l =
% arctan(w(x)/x)
global c_L S theta A_p theta_l                                             %#ok<REDEF>
% Check for required GUI inputs
y0 = str2double(get(handles.edtXOrigin,'String')); c_L.y0 = y0;
x0 = str2double(get(handles.edtJetCenter1,'String')); c_L.x0 = x0;
pxPermm = str2num(get(handles.edtScaleFile,'String')); %#ok<ST2NM>
avgStartPer = str2double(get(handles.edtAvgStart,'String'));
avgEndPer = str2double(get(handles.edtAvgEnd,'String'));
CRng = str2double(get(handles.edtCRng,'String'));
if isnan(x0) || isnan(y0)
    disp('A spray origin is required to perform spray measurements...')
    c_L = []; S = []; theta = []; A_p = []; theta_l = [];
    return
end
if isnan(pxPermm)
    disp('A pixel per mm value is required to perform spray measurements...')
    c_L = []; S = []; theta = []; A_p = []; theta_l = [];
    return
end
if isnan(avgStartPer) || isnan(avgEndPer)
    disp('An average start and average end point are required to perform spray measurements...')
    c_L = []; S = []; theta = []; A_p = []; theta_l = [];
    return
end
if logical(~nnz(img)) %if binary image is all zeros, create small zone at nozzle so code doesn't crash
    img(x0-1:x0,y0-1:y0) = 1;
end
% Rotate image to make this coding simpler... it was done for a 90 degree
% turned image.
img = transpose(img);

% Center Line (c_L) calculation
%   Get the nozzle origin and centroid coordinates, output the origin,
%   centroid, and an extrapolated line (that fits the two points). Output
%   these values to the c_L structure.
nozzleOrigin = [x0 y0];
cenPos = regionprops(img,'Centroid');
cenPos = cenPos.Centroid;
x_c = cenPos(1);
y_c = cenPos(2);
xd = [x_c x0];
yd = [y_c y0];
c_L.xs = [min(xd) max(xd)+10];
c_L.ys = polyval(polyfit(xd,yd,1),c_L.xs);
c_L.origin = nozzleOrigin;
c_L.cenPos = cenPos;

% Projected area (A_p) calculation
area = regionprops(img,'Area'); 

% Projected area (in mm^2)
A_p = area.Area*(1/pxPermm)^2;                                             %#ok<NASGU> 

% Spray angle (theta) calculation
box = regionprops(img,'BoundingBox'); box = box.BoundingBox;
% box(1) = upper left corner (x)
% box(2) = upper left corner (y)
% box(3) = x width
% box(4) = y width

pBox = round(box);
% Create a vector of spray widths starting at the nozzle origin and
% extending to the last pixel of the spray. Also calculated the total angle
% as a function of the distance from the origin.

% Initialize loop variables
startPix = round(nozzleOrigin(2));
endPix = pBox(2) + pBox(4);
endPix(endPix>size(img,1)) = size(img,1); % Fix for occasional problems 
                                          % with '??? Index exceeds matrix 
                                          % dimensions.' errors.
SPix = endPix - startPix;   % Length (in pixels) of the spray
%taken outside of conditional statement so spray angle information can be
%plotted for both tests
w = zeros(1,SPix);
theta_l = zeros(1,SPix);
j = 1;
for i = startPix:endPix
    w(j) = length(find(img(i,:)));
    theta_l(j) = 2*atand(w(j)/(2*j));
    j = j + 1;
end
if get(handles.ckbSiebers,'Value') == 1
    % Method from Siebers SAE 1999-01-0528 for spreading angle. See
    % appendix A, equation 01.
    Sover2 = round(SPix/2);
    halfSpray = img(startPix:end,:); halfSpray(Sover2:end,:)=0; % Cuts the spray in half
    area = regionprops(halfSpray,'Area');
    if length(area) > 1
        tmp = max(cell2mat(struct2cell(area)));
        clear area
        area.Area = tmp;
    end
    if length(area) < 1 || isempty(area.Area) 
        clear area
        area.Area = 0;
    end
    halfSprayArea = max(cat(1,area.Area)); % Finds maximum pixel area
    theta.theta = 2*atand(halfSprayArea/Sover2^2);
else
    % Compute the spray angle based on an average spray angle between a
    % starting point in the spray (expressed as a percentage of the total 
    % spray length) and an ending point in the spray.
    avgStart = round(avgStartPer*SPix);
    avgEnd = round(avgEndPer*SPix);
    theta.theta = mean(theta_l(avgStart:avgEnd));
end
% Radial distance from origin to center of mass
r = sqrt((x_c-x0)^2 + (y_c-y0)^2);

% Angle offset (from the centerline)
theta.alpha = asind((x_c-x0)/r); 

% Points on the arc (to the left and the right)
x_l = x_c - r*sind(theta.theta/2);
y_l = y0 + r*cosd(theta.theta/2);
x_r = x_c + r*sind(theta.theta/2);
y_r = y0 + r*cosd(theta.theta/2); 

% Left hand line
xd_l = [x_l x0];
yd_l = [y_l y0];
theta.xs_l = [min(xd_l)-100 max(xd_l)];
theta.ys_l = polyval(polyfit(xd_l,yd_l,1),theta.xs_l);

% Right hand line
xd_r = [x_r x0];
yd_r = [y_r y0];
theta.xs_r = [min(xd_r) max(xd_r)+100];
theta.ys_r = polyval(polyfit(xd_r,yd_r,1),theta.xs_r);

% Compute the penetration length (iterative)
onFraction = 1;
rFrac = round(0.9*r); % Start 75% of the way along the spray.
iter = 1;
theta_S = linspace(-theta.theta/4+theta.alpha,theta.theta/4+theta.alpha,400);
while onFraction > 0.5
    % Find an arc radius an angle of theta/2 wide near the end of the spray.
    % Discretize (by pixels) a circular path along that arc
    % Determine how many pixels along the path are on (1)
    % Divide by how many pixels are along the path.
    % If there are more pixels on than off, move one pixel outwards.
    % Continue this process until there are fewer on pixels than off pixels
    % (at least half of the pixels on the arc of theta/2 centered on the 
    % spray axis are off)
    
    rFrac = rFrac + 1; % Add one to the radius each iteration.
    
    % Points on the arc (keep this code for proper display of penetration
    % length)
    S.arc_x = (x0 + rFrac*sind(theta_S));
    S.arc_y = (y0 + rFrac*cosd(theta_S));
%     figure(15), clf, imshow(img) %check visually to see if this is working
%     hold on, plot(S.arc_x,S.arc_y,'--b')
%     plot(x0,y0,'+r')
%     plot(xd_l,yd_l,xd_r,yd_r,':')

    % Points on the arc (rounded to the nearest pixel)
    [arcPix_x m n] = unique(round(S.arc_x)); %#ok<NASGU>
    arcPix_y = round(S.arc_y(m));
    
    % Catch any points < 1
    arcPix_y(arcPix_y<1) = 1;
    
    % Count the on pixels along the arc
    num = 0;
    for i=1:length(arcPix_x)
        imgSize = size(img);
        if arcPix_y(i)>imgSize(1)
            arcPix_y(i) = imgSize(1);
        end
        if arcPix_x(i)>imgSize(2)
            arcPix_x(i) = imgSize(2);
        end
        if arcPix_x(i)<1
            arcPix_x(i) = 1;
        end
        if arcPix_y(i)<1
            arcPix_y(i) = 1;
        end
        if img(arcPix_y(i),arcPix_x(i))==1
            num = num + 1;
        end
    end
    den = length(arcPix_x);
    
    onFraction = num/den;
    
    iter = iter + 1;
    if iter > 500 % Increase this for larger images!!!
        disp('Maximum number of iterations reached for penetration distance calculation!')
        break
    end
end
S.SPix = rFrac;
S.S = (rFrac)*pxPermm; % Spray penetration distance in mm.

% Save output data in the handles structure
handles.c_L = c_L;
handles.S = S; 
handles.theta = theta; 
handles.A_p = A_p; 
handles.theta_l = theta_l;
guidata(hObject, handles)

% Update Measurements in GUI
set(handles.edtJetAngle1,'String',num2str(theta.theta,'%.1f'))
set(handles.edtJetPen1_mm,'String',num2str(S.S,'%.1f'))
set(handles.edtJetPen1_pixels,'String',num2str(S.SPix,'%.1f'))


% -------------------------------------------------------------------------
%                         Refresh Display
% -------------------------------------------------------------------------

function btnRefresh_Callback(hObject, eventdata, handles)
global images offsetWrite offsetRead currentFrame JB frameRate16
global TestImage1 t1 startFrame
Scale = str2num(get(handles.edtScaleFile,'String')); %#ok<ST2NM>
% Update currentFrame in GUI
set(handles.edtCurrentFrame, 'String', currentFrame);

 if get(handles.ckbUseSubtractionFrameView,'Value')
    subframe = get(handles.edtSubtractionFrame,'String');
    try subframe = round(str2double(subframe));
    catch
        set(handles.edtSubtractionFrame,'String',startFrame);
        subframe = startFrame;
    end
    if subframe == currentFrame
        subframe = startFrame;
    end
    if currentFrame == startFrame
        return
    end
    if subframe <= -1
        if currentFrame > startFrame
        subframe = currentFrame-1;
        else
            return
        end
    end
    
end

% Plot the image
axes(handles.axsOrigMovie)

TestImage1 = images(:,:,currentFrame + offsetWrite);
if get(handles.ckbUseSubtractionFrameView,'Value')
    TestImage1 = TestImage1 - images(:,:,subframe+offsetWrite) + 2000;
end
CRng = str2num(get(handles.edtCRng,'String'));
handles.hImage = imshow(TestImage1,CRng,'XData',[0 size(TestImage1,2)],'YData',[0 size(TestImage1,1)]);
guidata(hObject, handles)
set(gca,'Visible','on')

% Update the times on the GUI
injStartFrame = str2double(get(handles.edtInjStartFrame,'String'));
t2 = t1(currentFrame- startFrame + 1); 
set(handles.edtTime1,     'String', num2str(t2,'%6.1f'));

% If there is no boundary data for TEST1, do not plot boundary 2
% if ~isempty(JB{currentFrame + offsetRead,1})
%     set(handles.ckbJBFile1,'Value',1)
% else 
%     set(handles.ckbJBFile1,'Value',0)
% end

% ?
% if ~isempty(JB{currentFrame + offsetRead,3}) 
%     set(handles.ckbJPFile1,'Value',1);   
%     set(handles.ckbJGFile1,'Value',1); 
% else 
%     set(handles.ckbJPFile1,'Value',0); 
%     set(handles.ckbJGFile1,'Value',0);  
% end

% If there is no boundary data for TEST2, do not plot boundary 2
% if isempty(JB{currentFrame + offsetRead,6})==0; 
%     set(handles.ckbJBFile2,'Value',1);  
% else 
%     set(handles.ckbJBFile2,'Value',0); 
% end
% if isempty(JB{currentFrame + offsetRead,8})==0; 
%     set(handles.ckbJPFile2,'Value',1);    
%     set(handles.ckbJGFile2,'Value',1); 
% else 
%     set(handles.ckbJPFile2,'Value',0); 
%     set(handles.ckbJGFile2,'Value',0); 
% end

% MERGED FILE
% if isempty(JB{currentFrame + offsetRead,11})==0; 
%     set(handles.ckbJBFileSum,'Value',1); 
% else 
%     set(handles.ckbJBFileSum,'Value',0); 
% end
% if isempty(JB{currentFrame + offsetRead,12})==0; 
%     set(handles.ckbJPFileSum,'Value',1);   
%     set(handles.ckbJGFileSum,'Value',1); 
% else 
%     set(handles.ckbJPFileSum,'Value',0); 
%     set(handles.ckbJGFileSum,'Value',0);  
% end

% TEST 1
% test to see if geometry data is present    
if isempty(JB{currentFrame + offsetRead,4})==0;     
    JetAngle = num2str(JB{currentFrame + offsetRead,4}(1,4),'%10.1f');
    set(handles.edtJetAngle1,'String',JetAngle); 
    JetPen_pixels = num2str(JB{currentFrame + offsetRead,4}(1,2),'%10.1f');
    set(handles.edtJetPen1_pixels,'String',JetPen_pixels); 
    Scale = str2num(get(handles.edtScaleFile,'String')); %#ok<ST2NM>
    JetPen_mm = num2str(JB{currentFrame + offsetRead,4}(1,2) * Scale,'%10.1f');
    set(handles.edtJetPen1_mm,'String',JetPen_mm); 
else
    set(handles.edtJetAngle1,'String','-');
    set(handles.edtJetPen1_pixels,'String','-');
    set(handles.edtJetPen1_mm,'String','-');
end

if isempty(JB{currentFrame + offsetRead,5})==0; 
    set(handles.ckbXMarkFile1,'Value',1);    
else 
    set(handles.ckbXMarkFile1,'Value',0);  
end
if isempty(JB{currentFrame + offsetRead,10})==0; 
    set(handles.ckbXMarkFile2,'Value',1);    
else 
    set(handles.ckbXMarkFile2,'Value',0);  
end

% TEST 1
if isempty(JB{currentFrame + offsetRead,1})==0; %check to see if JetBoundary cell array is empty. If not (i.e. ==0) then cell contains boundary data that needs plotting
    if get(handles.ckbJB1,'Value')==1 %check to see user wants JetBoundary plotting
         x = JB{currentFrame + offsetRead,1}(:,1);   %x locations of boundary
         y = JB{currentFrame + offsetRead,1}(:,2);   %y locations of boundary
         axes(handles.axsOrigMovie)
         hold on 
         plot(x,y,'r-', ...
             'LineWidth',3); 
         hold off  
    end 
    set(handles.edtJBInput1_1, 'String', JB{currentFrame + offsetRead,2}(1,3)); %Update the analysis settings to the screen...
    set(handles.edtJBInput1_2, 'String', JB{currentFrame + offsetRead,2}(1,4));
    set(handles.edtJBInput1_3, 'String', JB{currentFrame + offsetRead,2}(1,5));
    set(handles.edtJBInput1_4, 'String', JB{currentFrame + offsetRead,2}(1,6));
    set(handles.edtJBInput1_5, 'String', JB{currentFrame + offsetRead,2}(1,7));
    set(handles.edtJBInput1_6, 'String', JB{currentFrame + offsetRead,2}(1,8));
    set(handles.edtJBInput1_7, 'String', JB{currentFrame + offsetRead,2}(1,9));
    set(handles.edtJBInput1_8, 'String', JB{currentFrame + offsetRead,2}(1,10));
    try % For newer data files it grabs from a permanent spot in the JB file
        set(handles.edtXOrigin,'String',JB{1,14}(1,6));
        set(handles.edtJetCenter1,'String',JB{1,14}(1,7));
    catch % Older files only update where the correct value was placed in each frame.
        set(handles.edtXOrigin,    'String', JB{currentFrame + offsetRead,4}(1,6));
        set(handles.edtJetCenter1, 'String', JB{currentFrame + offsetRead,4}(1,5));
    end
    try % Data files as of 2/26/10 can handle these
    set(handles.edtJetCenter1, 'String', JB{currentFrame + offsetRead,4}(1,5));
    set(handles.edtAvgStart,   'String', JB{currentFrame + offsetRead,4}(1,7));
    set(handles.edtAvgEnd,     'String', JB{currentFrame + offsetRead,4}(1,8));
    set(handles.ckbLiqCoreMask,'Value',JB{currentFrame + offsetRead,4}(1,9));
    set(handles.ckbComplement, 'Value',JB{currentFrame + offsetRead,4}(1,10));
    %set(handles.edtSubtractionFrame,'String',JB{currentFrame + offsetRead,4}(1,11));  % Commented out because it interfered with processing
    set(handles.ckbUseSubtractionFrame,'Value',JB{currentFrame + offsetRead,4}(1,12));
    set(handles.ckbSiebers,'Value',JB{currentFrame + offsetRead,4}(1,13));
    % Data files as of 9/22/10 can handle this one
    set(handles.edtThetaInput,'String',num2str(JB{currentFrame + offsetRead,4}(1,14)));
    catch % Older *.jb files may not so skip this step.
    end
    val = JB{currentFrame + offsetRead,2}(1,2); %number position in popup menu 1 from JB file 
    string_list = get(handles.pumStrategy1,'String'); %items in popup menu 1
    JOB = string_list{val}; % actual item selected in popup menu 1
    set(handles.txtMethod1, 'String', JOB);
    set(handles.txtCurrentJetCenter, 'String', JB{currentFrame + offsetRead,2}(1,11));
    set(handles.txtCurrentPercentAdj, 'String', JB{currentFrame + offsetRead,2}(1,12));
else
    set(handles.edtJBInput1_1, 'String', '-'); %Update the analysis settings to the screen...
    set(handles.edtJBInput1_2, 'String', '-');
    set(handles.edtJBInput1_3, 'String', '-');
    set(handles.edtJBInput1_4, 'String', '-');
    set(handles.edtJBInput1_5, 'String', '-');
    set(handles.edtJBInput1_6, 'String', '-');
    set(handles.edtJBInput1_7, 'String', '-');
    set(handles.edtJBInput1_8, 'String', '-');
    set(handles.txtMethod1, 'String', '-');
    set(handles.txtCurrentJetCenter, 'String', '-');
    set(handles.txtCurrentPercentAdj, 'String', '-');
end

% MERGED FILE
if get(handles.ckbJBSum,'Value')==1 %check to see user wants JetBoundary plotting
    %check to see if JetBoundary cell array is empty. If not (i.e. ==0) then cell contains boundary data that needs plotting
    if isempty(JB{currentFrame + offsetRead,11})==0; 
         x = JB{currentFrame + offsetRead,11}(:,1);   %x locations of boundary
         y = JB{currentFrame + offsetRead,11}(:,2);   %y locations of boundary
         hold on; plot(x,y,'y','LineWidth',3); hold off;           %plot boundary over underlying image
    end
end 

% TEST 1
if get(handles.ckbJP1,'Value') %check to see user wants JetPenetration plotting
    %check to see if JetBoundary cell array is empty. If not (i.e. ==0)
    %then cell contains boundary data that needs plotting
    if ~isempty(JB{currentFrame + offsetRead,3});
         x = JB{currentFrame + offsetRead,3}(:,1);   %x locations of boundary
         y = JB{currentFrame + offsetRead,3}(:,2);   %y locations of boundary
         
         % CHECK
         %{
         %plot boundary over underlying image
         hold on
         plot(x,y,'b','LineWidth',3); 
         hold off;           
         %}
    end
end
if isempty(JB{currentFrame + offsetRead,3})==0; 
     set(handles.txtCurrentJetCenter, 'String', JB{currentFrame + offsetRead,4}(1,5));
end
if get(handles.ckbJG1,'Value') %check to see user wants JetGeometry plotting
    %check to see if JetBoundary cell array is empty. If not (i.e. ==0)
    %then cell contains boundary data that needs plotting
    if isempty(JB{currentFrame + offsetRead,3})==0; 
         hfull = JB{currentFrame + offsetRead,4}(1,1); %load jet geometry data
         JetPen = JB{currentFrame + offsetRead,4}(1,2); %load jet geometry data
         hhalf = JB{currentFrame + offsetRead,4}(1,3); %load jet geometry data
         jetCenter = JB{currentFrame + offsetRead,4}(1,5); %load jet geometry data
         %set(handles.figure1,'CurrentAxes',handles.axsOrigMovie)
         axes(handles.axsOrigMovie); 
         hold on
         Xline = [0 JetPen/2 JetPen/2 0];
         Yline = [jetCenter jetCenter-hhalf jetCenter+hhalf jetCenter];
         line(Xline, Yline,'Color','g','LineWidth',2); 
         Xline = [0 JetPen JetPen 0];
         Yline = [jetCenter jetCenter-hfull jetCenter+hfull jetCenter];
         line(Xline, Yline,'Color','g','LineWidth',2);         
         hold off;
    end
end
if get(handles.ckbXMark1,'Value')==1 %check to see user wants X Mark plotting
    %check to see if JetBoundary cell array is empty. If not (i.e. ==0)
    %then cell contains boundary data that needs plotting
    if isempty(JB{currentFrame + offsetRead,5})==0; %check to see if location data is present
        dist = JB{currentFrame + offsetRead,5}(1,1);
        jetCenter = JB{currentFrame + offsetRead,5}(1,2);
        hold on
        plot(round(dist/Scale),jetCenter, ...
            'yx', ...
            'MarkerSize',25, ...
            'LineWidth',3, ...
            'MarkerEdgeColor','r')
        hold off
    end
end
if get(handles.ckbXMark2,'Value')==1 %check to see user wants X Mark plotting
    % Check to see if JetBoundary cell array is empty. If not (i.e. ==0)
    % then cell contains boundary data that needs plotting
    
    % Check to see if location data is present
    if isempty(JB{currentFrame + offsetRead,10})==0; 
        dist = JB{currentFrame + offsetRead,10}(1,1);
        jetCenter = JB{currentFrame + offsetRead,10}(1,2);
        hold on; plot(round(dist/Scale),jetCenter,'yx','MarkerSize',25,'LineWidth',3,'MarkerEdgeColor','m'); hold off;  % plot X marks the spot
    end
end

% TEST 2
if get(handles.ckbJP2,'Value')==1 %check to see user wants JetPenetration plotting
    %check to see if JetBoundary cell array is empty. If not (i.e. ==0)
    %then cell contains boundary data that needs plotting
    if isempty(JB{currentFrame + offsetRead,8})==0; 
         x = JB{currentFrame + offsetRead,8}(:,1);   %x locations of boundary
         y = JB{currentFrame + offsetRead,8}(:,2);   %y locations of boundary
         hold on; plot(x,y,'b','LineWidth',3); hold off;           %plot boundary over underlying image
         
    end
end

%if isempty(JB{edtCurrentFrame + offsetRead,3})==0; 
%     set(handles.txtCurrentJetCenter, 'String', JB{edtCurrentFrame + offsetRead,4}(1,5));
%end

if get(handles.ckbJG2,'Value')==1 %check to see user wants JetGeometry plotting
    %check to see if JetBoundary cell array is empty. If not (i.e. ==0)
    %then cell contains boundary data that needs plotting
    if isempty(JB{currentFrame + offsetRead,8})==0; 
         hfull = JB{currentFrame + offsetRead,9}(1,1); %load jet geometry data
         JetPen = JB{currentFrame + offsetRead,9}(1,2); %load jet geometry data
         hhalf = JB{currentFrame + offsetRead,9}(1,3); %load jet geometry data
         jetCenter = JB{currentFrame + offsetRead,9}(1,5); %load jet geometry data
         %set(handles.figure1,'CurrentAxes',handles.axsOrigMovie)
         axes(handles.axsOrigMovie); 
         hold on
         Xline = [0 JetPen/2 JetPen/2 0];
         Yline = [jetCenter jetCenter-hhalf jetCenter+hhalf jetCenter];
         line(Xline, Yline,'Color','g','LineWidth',2); 
         Xline = [0 JetPen JetPen 0];
         Yline = [jetCenter jetCenter-hfull jetCenter+hfull jetCenter];
         line(Xline, Yline,'Color','g','LineWidth',2);         
         hold off;
    end
end

% Merged file
if get(handles.ckbJPSum,'Value')==1 %check to see user wants JetPenetration plotting
    %check to see if JetBoundary cell array is empty. If not (i.e. ==0)
    %then cell contains boundary data that needs plotting
    if isempty(JB{currentFrame + offsetRead,12})==0; 
         x = JB{currentFrame + offsetRead,12}(:,1);   %x locations of boundary
         y = JB{currentFrame + offsetRead,12}(:,2);   %y locations of boundary
         hold on; plot(x,y,'b','LineWidth',3); hold off;           %plot boundary over underlying image
         
    end
end

%if isempty(JB{edtCurrentFrame + offsetRead,3})==0; 
%     set(handles.txtCurrentJetCenter, 'String', JB{edtCurrentFrame + offsetRead,4}(1,5));
%end
if get(handles.ckbJGSum,'Value')==1 %check to see user wants JetGeometry plotting
    %check to see if JetBoundary cell array is empty. If not (i.e. ==0)
    %then cell contains boundary data that needs plotting
    if isempty(JB{currentFrame + offsetRead,12})==0; 
         hfull = JB{currentFrame + offsetRead,13}(1,1); %load jet geometry data
         JetPen = JB{currentFrame + offsetRead,13}(1,2); %load jet geometry data
         hhalf = JB{currentFrame + offsetRead,13}(1,3); %load jet geometry data
         jetCenter = JB{currentFrame + offsetRead,13}(1,5); %load jet geometry data
         %set(handles.figure1,'CurrentAxes',handles.axsOrigMovie)
         axes(handles.axsOrigMovie); 
         hold on
         Xline = [0 JetPen/2 JetPen/2 0];
         Yline = [jetCenter jetCenter-hhalf jetCenter+hhalf jetCenter];
         line(Xline, Yline,'Color','g','LineWidth',2); 
         Xline = [0 JetPen JetPen 0];
         Yline = [jetCenter jetCenter-hfull jetCenter+hfull jetCenter];
         line(Xline, Yline,'Color','g','LineWidth',2);         
         hold off;
    end
end



% -------------------------------------------------------------------------
%                         KeyPress Functions
% -------------------------------------------------------------------------

function figure1_KeyPressFcn(hObject, eventdata, handles)

% Main Key Press Function
% A call to this function should be included in each button, radio button,
% check box, and popup menu. See the other examples for exactly how.

% Initialize the modifier key values
control = 0;                                                               
alt     = 0;                                                               %#ok<NASGU>
shift   = 0;                                                               

% Handle versions of MATLAB previous to R2009a (I think direct eventdata
%    was release sometime in 2008...)
if verLessThan('Matlab','7.8.0.347')
    currChar = get(handles.figure1,'CurrentCharacter');                    %#ok<NASGU>
    currKey  = get(handles.figure1,'CurrentKey');                          
    currMod  = get(handles.figure1,'CurrentModifier');                     
else
    currChar = eventdata.Character;                                        %#ok<NASGU>
    currMod  = eventdata.Modifier;
    currKey  = eventdata.Key;                                              
end

% Determine which modifiers have been pressed
for i=1:length(currMod)
    switch(currMod{i})
        case 'control'
            control = 1;                                                   %#ok<NASGU>
        case 'alt'
            alt = 1;                                                       %#ok<NASGU>
        case 'shift'
            shift = 1;                                                     %#ok<NASGU>
    end
end

if strcmp(currKey,'comma') || strcmp(currKey,'leftarrow')
    btnPreviousFrame_Callback(hObject, eventdata, handles)
elseif strcmp(currKey,'period') || strcmp(currKey,'rightarrow')
    btnNextFrame_Callback(hObject, eventdata, handles)
elseif strcmp(currKey,'uparrow')
    btnThresholdPlus1_Callback(hObject, eventdata, handles)
elseif strcmp(currKey,'downarrow')
    btnThresholdMinus1_Callback(hObject, eventdata, handles)
elseif strcmp(currKey,'t')
    btnTest1_Callback(hObject, eventdata, handles)
elseif strcmp(currKey,'l')
    btnLoop_Callback(hObject, eventdata, handles)
elseif strcmp(currKey,'semicolon')
    set(handles.rdbStop,'Value',1)
elseif strcmp(currKey,'1') 
    set(handles.pumStrategy1,'Value',1)
    pumStrategy1_Callback(hObject, eventdata, handles)
elseif control && strcmp(currKey,'2')
    set(handles.pumStrategy1,'Value',2)
    pumStrategy1_Callback(hObject, eventdata, handles)
elseif control && strcmp(currKey,'3')
    set(handles.pumStrategy1,'Value',3)
    pumStrategy1_Callback(hObject, eventdata, handles)
elseif control && strcmp(currKey,'4')
    set(handles.pumStrategy1,'Value',4)
    pumStrategy1_Callback(hObject, eventdata, handles)
elseif control && strcmp(currKey,'5')
    set(handles.pumStrategy1,'Value',5)
    pumStrategy1_Callback(hObject, eventdata, handles)
elseif strcmp(currKey,'m')
    if get(handles.ckbLiqCoreMask,'Value') == 1
        set(handles.ckbLiqCoreMask,'Value',0)
    else
        set(handles.ckbLiqCoreMask,'Value',1)
    end
    btnTest1_Callback(hObject, eventdata, handles)
elseif strcmp(currKey,'c')
    if get(handles.ckbComplement,'Value') == 1
        set(handles.ckbComplement,'Value',0)
    else
        set(handles.ckbComplement,'Value',1)
    end
    btnTest1_Callback(hObject, eventdata, handles)
elseif strcmp(currKey,'u') && shift == 0
    btnSwitchNums_Callback(hObject, eventdata, handles)
elseif shift && strcmp(currKey,'u')
    btnUnlock_Callback(hObject, eventdata, handles)
elseif shift && strcmp(currKey,'s')
    btnSave_Callback(hObject, eventdata, handles)
elseif control && strcmp(currKey,'s')
    uiSaveJB_Callback_ClickedCallback(hObject, eventdata, handles)
elseif strcmp(currKey,'b')
    btnComputeAll1_Callback(hObject, eventdata, handles)
elseif strcmp(currKey,'i')
    btnTransferInputs1_Callback(hObject, eventdata, handles)
elseif strcmp(currKey,'r')
    btnRefresh_Callback(hObject, eventdata, handles)
end


function btnAVI_AllFrames_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnAVI_AllFrames_Callback(hObject, eventdata, handles)
end
function btnAVI_FromInjStart_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnAVI_FromInjStart_Callback(hObject, eventdata, handles)
end
function btnAVI_TestSettings_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnAVI_TestSettings_Callback(hObject, eventdata, handles)
end
function btnBrowse_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnBrowse_Callback(hObject, eventdata, handles)
end
function btnCreateAVI_KeyPressFcn(hObject, eventdata, handles)
function btnComputeAll1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnComputeAll1_Callback(hObject, eventdata, handles)
end
function btnDilateMinus1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnDilateMinus1_Callback(hObject, eventdata, handles)
end
function btnDilatePlus1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnDilatePlus1_Callback(hObject, eventdata, handles)
end
function btnErodeMinus1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnErodeMinus1_Callback(hObject, eventdata, handles)
end
function btnErodePlus1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnErodePlus1_Callback(hObject, eventdata, handles)
end
function btnLoadCine_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnLoadCine_Callback(hObject, eventdata, handles)
end
function btnLoadJB_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnLoadJB_Callback(hObject, eventdata, handles)
end
function btnLoop_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnLoop_Callback(hObject, eventdata, handles)
end
function btnMarker1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnMarker1_Callback(hObject, eventdata, handles)
end
function btnMinusJP1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnMinusJP1_Callback(hObject, eventdata, handles)
end
function btnNextFrame_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnNextFrame_Callback(hObject, eventdata, handles)
end
function btnPlusJP1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnPlusJP1_Callback(hObject, eventdata, handles)
end
function btnPreviousFrame_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnPreviousFrame_Callback(hObject, eventdata, handles)
end
function btnRefresh_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnRefresh_Callback(hObject, eventdata, handles)
end
function btnSave_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnSave_Callback(hObject, eventdata, handles)
end
function btnSaveJB_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnSaveJB_Callback(hObject, eventdata, handles)
end
function btnStoreFill_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnStoreFill_Callback(hObject, eventdata, handles)
end
function btnStoreTransfer_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnStoreTransfer_Callback(hObject, eventdata, handles)
end
function btnTest1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnTest1_Callback(hObject, eventdata, handles)
end
function btnTestMarker1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnTestMarker1_Callback(hObject, eventdata, handles)
end
function btnThresholdMinus1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnThresholdMinus1_Callback(hObject, eventdata, handles)
end
function btnThresholdPlus1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnThresholdPlus1_Callback(hObject, eventdata, handles)
end
function btnTransferInputs1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnTransferInputs1_Callback(hObject, eventdata, handles)
end
function btnUnlock_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    btnUnlock_Callback(hObject, eventdata, handles)
end
function ckbLoadSameFrameNumbers_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    ckbLoadSameFrameNumbers_Callback(hObject, eventdata, handles)
end
function ckbMarkerActive1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    ckbMarkerActive1_Callback(hObject, eventdata, handles)
end
function ckbComplement_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    ckbComplement_Callback(hObject, eventdata, handles)
end
function ckbLiqCoreMask_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    ckbLiqCoreMask_Callback(hObject, eventdata, handles)
end
function ckbUseSubtractionFrame_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    ckbUseSubtractionFrame_Callback(hObject, eventdata, handles)
end
function ckbUseSubtractionFrameView_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    ckbUseSubtractionFrame_Callback(hObject, eventdata, handles)
end
function edtsavePath_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    edtSavePath_Callback(hObject, eventdata, handles)
end
function edtCRng_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    edtCRng_Callback(hObject, eventdata, handles)
end
function ckbStore_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    ckbStore_Callback(hObject, eventdata, handles)
end
function pumStrategy1_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    pumStrategy1_Callback(hObject, eventdata, handles)
end
function rdbStop_KeyPressFcn(hObject, eventdata, handles)
currChar = get(handles.figure1,'CurrentCharacter');
if ~isequal(currChar,char(13))
	figure1_KeyPressFcn(hObject, eventdata, handles)
else
    rdbStop_Callback(hObject, eventdata, handles)
end
function udpateGUIPlots(hObject, handles)

global c_L S theta_l theta TestImage1 x y dist jetCenter dimIm   

axes(handles.axsOrigMovie);                                           %#ok<*MAXES>
CRng = str2num(get(handles.edtCRng,'String'));
handles.hImage = imshow(TestImage1,CRng,'XData',[0 size(TestImage1,2)],'YData',[0 size(TestImage1,1)]);
guidata(hObject, handles)
set(gca,'Visible','on')
hold on

if ~isempty(c_L)
    % Plot boundary over spray image        
    plot(x,y,'r','LineWidth',3)

    % Plot "x marks the spot" if possible (estimate of penetration distance)
    plot(round(dist),jetCenter, ...
            'yx', ...
            'MarkerSize',25, ...
            'LineWidth',3, ...
            'MarkerEdgeColor','r')

    % Plot nozzle origin (x and y are reversed due to measureSpray
    % orientation)
    x0 = c_L.y0;
    y0 = c_L.x0;
    plot(x0,y0,'b*')

    % Plot center of mass
    x_c = c_L.cenPos(2);
    y_c = c_L.cenPos(1);
    plot(x_c,y_c,'b*')

    % Plot a line through the center of mass
    xd = [x_c x0];
    yd = [y_c y0];
    xs = [min(xd) max(xd)+255];
    ys = polyval(polyfit(xd,yd,1),xs);
    plot(xs, ys, 'b--')

    % Radial distance from origin to center of mass
    r = sqrt((x_c-x0)^2 + (y_c-y0)^2);

    % Points on the arc (upper and lower)
    y_u = y_c - r*sind(theta.theta/2); %"left" from measureSpray is upper line here
    x_u = x0 + r*cosd(theta.theta/2);
    y_l = y_c + r*sind(theta.theta/2);
    x_l = x0 + r*cosd(theta.theta/2);
    
    % Plot upper line
    xd_u = [x0 x_l];
    yd_u = [y0 y_l];
    xs_u = [min(xd_u) max(xd_u)+250];
    ys_u = polyval(polyfit(xd_u,yd_u,1),xs_u);
    plot(xs_u,ys_u,'y--')

    % Lower line
    xd_l = [x0 x_u];
    yd_l = [y0 y_u];
    xs_l = [min(xd_l) max(xd_l)+250];
    ys_l = polyval(polyfit(xd_l,yd_l,1),xs_l);
    plot(xs_l,ys_l,'y--')

    % Plot penetration length arc
    arc_x = S.arc_y;
    arc_y = S.arc_x;
    plot(arc_x,arc_y,'b:','LineWidth',3)


    hold off     

    axes(handles.axsTheta_l)
    plot(theta_l), title('\theta(x)'), ...
                   xlabel('pixels'), ...
                   ylabel('\theta [degrees]')
end
% Key combinations:
%{
if control==1 && strcmp(currKey,'z') % Undo last action
    undo(hObject, eventdata, handles)
elseif control==1 && strcmp(currKey,'y') % Redo last action
    redo(hObject, eventdata, handles)
elseif strcmp(currChar,',')     % Previous Aggregate (<)
    pbPreviousAggregate_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'.')     % Next Aggregate  (>)
    pbNextAggregate_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,']')     % Threshold + ([)
    pbThresholdPlus_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'[')     % Threshold - (])
    pbThresholdMinus_Callback(hObject, eventdata, handles)
elseif strcmp(currKey,'semicolon') % Delte pixel area - (;)
    pbDeletePixelNegative_Callback(hObject, eventdata, handles)
elseif strcmp(currKey,'quote') % Delete pixel area + (")
    pbDeletePixelPositive_Callback(hObject, eventdata, handles)
elseif strcmp(currKey,'delete') % (Delete) from perimeter file
    pbDeleteFromFile_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'a')     % (a)dd to perimeter file
    pbAddToFile_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'b')     % Select (b)iggest Region
    pbBiggestRegion_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'c')     % New labels and RoG (c)alculations
    pbNewLabel_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'d')     % (d)ilate
    pbDilate_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'e')     % (e)rode
    pbErode_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'f')     % (f)lood fill
    pbFloodFill_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'F')     % (F)ind Edges
    pbFindEdges_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'h')     % (h)istogram
    pbHistogram_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'i')     % Plot entire (i)mage
    pbPlotEntireImage_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'l')     % (l)oad Files
    pbLoad_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'m')     % (m)easure
    pbMeasure_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'o')     % (o)utput RoGs
    pbOutputROGs_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'p')     % Add/Remove (p)ixels
    pbAddRemovePixels_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'r') % (r)efill
    pbRefill_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'s') % (s)pline White
    pbSplineWhite_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'S') % (S)pline Black
    pbSplineBlack_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'t') % (t)hreshold
    pbThreshold_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'T') % Auto (T)hreshold
    pbThresholdAuto_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'x') % Delete Selected Area (x)
    pbDeleteArea_Callback(hObject, eventdata, handles)
elseif strcmp(currChar,'z')         || strcmp(currChar,'Z')      || ...
       strcmp(currChar,'+')         || strcmp(currChar,'-')      || ...
       strcmp(currKey,'leftarrow')  || strcmp(currKey,'numpad4') || ...
       strcmp(currKey,'rightarrow') || strcmp(currKey,'numpad6') || ...
       strcmp(currKey,'uparrow')    || strcmp(currKey,'numpad8') || ...
       strcmp(currKey,'downarrow')  || strcmp(currKey,'numpad2') || ...
       strcmp(currChar,'*')         || strcmp(currKey,'equal')
       % Any zoom/pan keys go here.  They will be handled by a zoom and pan 
       % function.
    zoomAndPan(hObject,eventdata,handles,currChar,currKey)
end
%}

% These functions are likely no longer in use... not sure...
%{
function MergeNumber_Callback(hObject, eventdata, handles)
function MergeNumber_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function ScaleMerge_Callback(hObject, eventdata, handles)

Scale = str2num(get(handles.edtScaleFile, 'String'));
set(handles.Scale,      'String', Scale); 
set(handles.Scale2,     'String', Scale); 
set(handles.ScaleMerge, 'String', Scale); 
ScaleFile_Callback(hObject, eventdata, handles)
function ScaleMerge_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function Scale2_Callback(hObject, eventdata, handles)
Scale = str2num(get(handles.edtScaleFile, 'String'));
set(handles.Scale, 'String', Scale); 
set(handles.Scale2, 'String', Scale); 
set(handles.ScaleMerge, 'String', Scale); 
ScaleFile_Callback(hObject, eventdata, handles)
function Scale2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function NumberofLoops_Callback(hObject, eventdata, handles)
function NumberofLoops_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function Scale_Callback(hObject, eventdata, handles)
Scale = str2num(get(handles.edtScaleFile, 'String'));
set(handles.Scale, 'String', Scale); 
set(handles.Scale2, 'String', Scale); 
set(handles.ScaleMerge, 'String', Scale); 
ScaleFile_Callback(hObject, eventdata, handles)
function Scale_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function InjStartFrame2_Callback(hObject, eventdata, handles)
injStartFrame = get(handles.InjStartFrame2,'String');
set(handles.edtInjStartFrame,'String',injStartFrame);
function InjStartFrame2_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% -------------------------------------------------------------------------
%                          AVI Creator
% -------------------------------------------------------------------------

% AVI Creator Callbacks
function btnAVI_AllFrames_Callback(hObject, eventdata, handles)
global startFrame totalFrames
set(handles.edtAVI_Start, 'String', num2str(startFrame));
set(handles.edtAVI_End,   'String', num2str(startFrame + totalFrames - 1));
function btnAVI_FromInjStart_Callback(hObject, eventdata, handles)
global startFrame totalFrames
set(handles.edtAVI_Start,'String', get(handles.edtInjStartFrame,'String'));
set(handles.edtAVI_End,  'String', num2str(startFrame + totalFrames - 1));
function btnAVI_TestSettings_Callback(hObject, eventdata, handles)
global JB currentFrame images offsetRead offsetWrite frameRate16  x y 
injStartFrame  = str2double(get(handles.edtInjStartFrame,     'String'));
Scale          = str2num(get(handles.edtScaleFile,         'String'));
AxialOrigin    = str2double(get(handles.edtAxialOrigin,       'String'));
RadialOrigin   = str2double(get(handles.edtRadialOrigin,      'String'));
JB_Colour      = get(handles.edtJB_Color,                     'String');
LineThickness  = str2double(get(handles.edtLineThickness,     'String'));
%AVI_Start      = str2double(get(handles.edtAVI_Start,         'String'));
%AVI_End        = str2double(get(handles.edtAVI_End,           'String'));
x_Range        = str2num(get(handles.edtX_Range,              'String'));  %#ok<ST2NM>
y_Range        = str2num(get(handles.edtY_Range,              'String'));  %#ok<ST2NM>
x_Axis         = str2num(get(handles.edtX_Axis,               'String'));  %#ok<ST2NM>
y_Axis         = str2num(get(handles.edtY_Axis,               'String'));  %#ok<ST2NM>
IntensityRange = str2num(get(handles.edtIntensityRange,       'String'));  %#ok<ST2NM>
TimeStampPos   = str2num(get(handles.edtTimeStampPos,         'String'));  %#ok<ST2NM>
Rotation       = str2double(get(handles.edtAVI_Rotation,      'String'));
Magnification  = str2double(get(handles.edtAVI_Magnification, 'String'));
%Rectangle      = str2num(get(handles.edtAVI_Rectangle,        'String')); %#ok<ST2NM>

% Size of image in pixels
dimIm = size(images(:,:,currentFrame + offsetWrite));

% Size of the image in pixels using the injector position as the origin
xval  = (1:dimIm(2)-AxialOrigin)*Scale;
rad   = (1:dimIm(1)-RadialOrigin)*Scale; 

xind=[xval(1) xval(end)]; 
yind=[rad(1) rad(end)]; % min and max of the x and y (radial) axis
CRng = IntensityRange; %image intensity range
yr=y_Range;
xr=x_Range; 
xt=x_Axis; 
yt=y_Axis; % range of imag to be plotted

figure;
currentFrame = str2double(get(handles.edtAVI_FrameTest, 'String'));
Time = (currentFrame - injStartFrame) * (1000000/frameRate16);
X = images(:,:,currentFrame + offsetWrite);
if Rotation ~= 0; 
    X=imrotate(X,Rotation,'nearest','crop');
end
imshow(X,CRng, ...
       'XData',xind, ...
       'Ydata',yind, ...
       'InitialMagnification',Magnification)
set(gca,'Visible','On','TickDir','out','XTick',xt,'YTick',yt,...
        'LineWidth',1,'Xlim',xr,'Ylim',yr,'FontSize',12)

    
if isempty(JB{currentFrame + offsetRead,11})==0
   x = JB{currentFrame + offsetRead,11}(:,1);   %x locations of boundary
   y = JB{currentFrame + offsetRead,11}(:,2);   %y locations of boundary
   x_mm = (x - AxialOrigin) * Scale; y_mm = (y - RadialOrigin) * Scale;
   hold on, plot(x_mm, y_mm, JB_Colour,'LineWidth',LineThickness);
   set(gcf,'Color','w')
end
    
text(TimeStampPos(1),TimeStampPos(2), ...
    [num2str(Time,'%6.2f\n') ' \mus'], ...
    'fontsize',16, ...
    'color',[1 1 1], ...
    'backgroundcolor',[0 0 0]);
axis tight
function btnCreateAVI_Callback(hObject, eventdata, handles)
global JB currentFrame images offsetRead offsetWrite frameRate16 x y 
injStartFrame  = str2double(get(handles.edtInjStartFrame,     'String'));
Scale          = str2num(get(handles.edtScaleFile,         'String'));
AxialOrigin    = str2double(get(handles.edtAxialOrigin,       'String'));
RadialOrigin   = str2double(get(handles.edtRadialOrigin,      'String'));
JB_Colour      = get(handles.edtJB_Color,                     'String');
LineThickness  = str2double(get(handles.edtLineThickness,     'String'));
AVI_Start      = str2double(get(handles.edtAVI_Start,         'String'));
AVI_End        = str2double(get(handles.edtAVI_End,           'String'));
x_Range        = str2num(get(handles.edtX_Range,              'String'));  %#ok<ST2NM>
y_Range        = str2num(get(handles.edtY_Range,              'String'));  %#ok<ST2NM>
x_Axis         = str2num(get(handles.edtX_Axis,               'String'));  %#ok<ST2NM>
y_Axis         = str2num(get(handles.edtY_Axis,               'String'));  %#ok<ST2NM>
IntensityRange = str2num(get(handles.edtIntensityRange,       'String'));  %#ok<ST2NM>
TimeStampPos   = str2num(get(handles.edtTimeStampPos,         'String'));  %#ok<ST2NM>
Rotation       = str2double(get(handles.edtAVI_Rotation,      'String'));
Magnification  = str2double(get(handles.edtAVI_Magnification, 'String'));
Rectangle      = str2num(get(handles.edtAVI_Rectangle,        'String'));  %#ok<ST2NM>

% Size of image in pixels
dimIm = size(images(:,:,currentFrame + offsetWrite));

% Size of the image in pixels using the injector position as the origin
xval  = (1:dimIm(2)-AxialOrigin)*Scale;
rad   = (1:dimIm(1)-RadialOrigin)*Scale; 

xind=[xval(1) xval(end)]; 
yind=[rad(1) rad(end)]; % min and max of the x and y (radial) axis
CRng = IntensityRange; %image intensity range
yr=y_Range;
xr=x_Range; 
xt=x_Axis; 
yt=y_Axis; % range of imag to be plotted

j=0;
figure(1); clf;
for currentFrame=AVI_Start:AVI_End
    Time = (currentFrame - injStartFrame) * (1000000/frameRate16);
    if currentFrame==AVI_Start
        X = images(:,:,currentFrame + offsetWrite);
    else
        % frame subtraction, SK110608
        X = (images(:,:,currentFrame + offsetWrite) - ...
             images(:,:,currentFrame -1 + offsetWrite)+2500); 
    end
    if Rotation ~= 0; X=imrotate(X,Rotation,'nearest','crop'); end
    figure(1); clf;
    imshow(X,CRng,'XData',xind, ...
                  'Ydata',yind, ...
                  'InitialMagnification',Magnification)
    set(gca,'Visible','On','TickDir','out','XTick',xt,'YTick',yt,...
        'LineWidth',2.5,'Xlim',xr,'Ylim',yr,'FontSize',20)
    if isempty(JB{currentFrame + offsetRead,11})==0
        % x and y boundary locations
        x = JB{currentFrame + offsetRead,11}(:,1);   
        y = JB{currentFrame + offsetRead,11}(:,2);   
        x_mm = (x - AxialOrigin)  * Scale; 
        y_mm = (y - RadialOrigin) * Scale;
        hold on, plot(x_mm, y_mm, JB_Colour,'LineWidth',LineThickness);
        set(gcf,'Color','w')
    end
    
    text(TimeStampPos(1),TimeStampPos(2), ...
        [num2str(Time,'%6.0f\n') ' \mus'], ...
        'fontsize',18, ...
        'color',[1 1 1], ...
        'backgroundcolor',[0 0 0]);
    axis tight
    j=j+1;
    M(j)=getframe(gcf, Rectangle); 
end

%figure
%figure(99999),clf,image(M(1).cdata);
%colormap(F.colormap);

fprintf('writing AVI file...\t');
movie2avi(M,'test.avi','fps',5,'compression','none');
fprintf('done\n');  

timg = AVI_Start:35:AVI_End;
%timg=[1:5];
if 1
    num =length(timg); figure(99999), clf; Xc=[];
    for i=1:num
        a = timg(i);
        [X,map]=frame2im( M(a) );                                          %#ok<NASGU>
        Xc=[Xc; X;];
    end
    figure(99999), imshow(Xc)
end
function edtAVI_End_Callback(hObject, eventdata, handles)
global startFrame totalFrames
AVI_End = str2double(get(handles.edtAVI_End,'String'));
if AVI_End > startFrame + totalFrames - 1;
   AVI_End = startFrame + totalFrames - 1;
   set(handles.edtAVI_End,'String', num2str(AVI_End));
end
function edtAVI_FrameTest_Callback(hObject, eventdata, handles)
function edtAVI_Magnification_Callback(hObject, eventdata, handles)
function edtAVI_Rectangle_Callback(hObject, eventdata, handles)
function edtAVI_Rotation_Callback(hObject, eventdata, handles)
function edtAVI_Start_Callback(hObject, eventdata, handles)
global startFrame
AVI_Start = str2double(get(handles.edtAVI_Start,'String'));
if AVI_Start < startFrame;
   AVI_Start = startFrame;
   set(handles.edtAVI_Start,'String', num2str(AVI_Start));
end
function edtAxialOrigin_Callback(hObject, eventdata, handles)
function edtIntensityRange_Callback(hObject, eventdata, handles)
function edtJB_Color_Callback(hObject, eventdata, handles)
function edtLineThickness_Callback(hObject, eventdata, handles)
function edtRadialOrigin_Callback(hObject, eventdata, handles)
function edtTimeStampPos_Callback(hObject, eventdata, handles)
function edtX_Axis_Callback(hObject, eventdata, handles)
function edtY_Axis_Callback(hObject, eventdata, handles)
function edtX_Range_Callback(hObject, eventdata, handles)
function edtY_Range_Callback(hObject, eventdata, handles)

% AVI Creator Create Functions
function edtAVI_End_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtAVI_FrameTest_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtAVI_Magnification_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtAVI_Rectangle_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtAVI_Rotation_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtAVI_Start_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtAxialOrigin_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtIntensityRange_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtJB_Color_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtLineThickness_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtRadialOrigin_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtTimeStampPos_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtX_Axis_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtY_Axis_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtX_Range_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edtY_Range_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), ...
        get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
%}

% These functiosn are almost certainly not in use and were just never
% deleted.
%{
function pushbutton22_Callback(hObject, eventdata, handles)
function pushbutton63_Callback(hObject, eventdata, handles)
function pushbutton64_Callback(hObject, eventdata, handles)
function pushbutton65_Callback(hObject, eventdata, handles)
function radiobutton3_Callback(hObject, eventdata, handles)
function edit32_Callback(hObject, eventdata, handles)
function edit32_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit38_Callback(hObject, eventdata, handles)
function edit38_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit39_Callback(hObject, eventdata, handles)
function edit39_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit40_Callback(hObject, eventdata, handles)
function edit40_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit41_Callback(hObject, eventdata, handles)
function edit41_CreateFcn(hObject, eventdata, handles)

if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit139_Callback(hObject, eventdata, handles)
function edit139_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit140_Callback(hObject, eventdata, handles)
function edit140_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function edit141_Callback(hObject, eventdata, handles)
function edit141_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function slider3_Callback(hObject, eventdata, handles)
function slider3_CreateFcn(hObject, eventdata, handles)
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end
%}


% Included to stop error message from coming up... figure out a way to
% delete this sometime (uipanel14 does not exist but deleting this throws
% errors) -RKG 12/15/09
function uipanel4_ResizeFcn(hObject,eventdata,handles)




















function figure1_CloseRequestFcn(hObject, eventdata, handles)
delete(hObject);

% Button & WindowButtonDownFcn fix a MATLAB bug which causes focus to go to
% the command window instead of the figure window after the figure window
% is clicked. This fixes keyboard function issues.

function figure1_ButtonDownFcn(hObject, eventdata, handles)
figure(hObject)

function figure1_WindowButtonDownFcn(hObject, eventdata, handles)
figure(hObject)

% uiSaveJB allows the user to click a save button in the upper right corner
% to save rather than clicking the save button on the GUI. This does not
% yet to any error handling (like checking to see if any JB work has been
% done)
function uiSaveJB_Callback_ClickedCallback(hObject, eventdata, handles)
btnSaveJB_Callback(hObject, eventdata, handles)
load file_save_gray.mat
set(findobj('-regexp','tag','uiSaveJB'),'CData',iconGray)

function ckbUseSubtractionFrame_Callback(hObject, eventdata, handles)
if ~get(handles.ckbUseSubtractionFrameView,'Value')
    if get(handles.ckbUseSubtractionFrame,'Value')
        set(handles.edtSubtractionFrame,'Enable','on');
    else
        set(handles.edtSubtractionFrame,'Enable','off');
    end
end
function ckbTransferAllInputsFromJB_Callback(hObject, eventdata, handles)

function ckbSiebers_Callback(hObject, eventdata, handles)
if get(handles.ckbSiebers,'Value') == 1
    set(handles.edtAvgStart,'Enable','Off')
    set(handles.edtAvgEnd  ,'Enable','Off')
    set(handles.text132    ,'Enable','Off')
    set(handles.text133    ,'Enable','Off')
else
    set(handles.edtAvgStart,'Enable','On')
    set(handles.edtAvgEnd  ,'Enable','On')
    set(handles.text132    ,'Enable','On')
    set(handles.text133    ,'Enable','On')
end

function ckbUseSubtractionFrameView_Callback(hObject, eventdata, handles)
if ~get(handles.ckbUseSubtractionFrame,'Value')
    if get(handles.ckbUseSubtractionFrameView,'Value')
        set(handles.edtSubtractionFrame,'Enable','on');
    else
        set(handles.edtSubtractionFrame,'Enable','off');
    end
end

function edtThetaInput_Callback(hObject, eventdata, handles)
function edtThetaInput_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
function btnFreehandDraw_Callback(hObject, eventdata, handles)
% This works but desperately needs some cleanup!! 
% Done the morning of my last day at Sandia. -RKG

global images offsetWrite offsetRead startFrame currentFrame JB frameRate16  
global Orifice Density InjPress TestImage1 boundary t1
global x y dist jetCenter dimIm   

h = imfreehand(handles.axsOrigMovie,'Closed','False');
binaryMask = h.createMask(handles.hImage);

%figure,imshow(binaryMask);

structBoundaries = bwboundaries(binaryMask);
xy=structBoundaries{1}; % Get n by 2 array of x,y coordinates.
x = xy(:, 2); % Columns.
y = xy(:, 1); % Rows.
%plot(x, y, 'LineWidth', 2);

% Show the user that changes have been made to the JB structure which can now be saved 
set(handles.btnSaveJB, 'Enable', 'On'); 
% Change the save icon to blue (from gray)
load file_save.mat % Contains blue save icon data
set(findobj('-regexp','tag','uiSaveJB'),'CData',icon)     

% Enable GUI boundary and file checkboxes
set(handles.ckbJB1,     'Value', 1); 
set(handles.ckbJBFile1, 'Value', 1); 
set(handles.ckbJP1,     'Value', 1); 
set(handles.ckbJPFile1, 'Value', 1); 

% Get popup menu selection
val = get(handles.pumStrategy1,'Value'); %number position in popup menu 1 
string_list = get(handles.pumStrategy1,'String'); %items in popup menu 1
JOB = string_list{val}; % Actual item selected in popup menu 1

%Get subtraction frame number
% :TEST for Viewing vs Calculating:
%subtractbool = get(handles.ckbUseSubtractionFrame,'Value');
%if get(handles.ckbUseSubtractionFrame,'Value')
%    subtractbool = 1; %1 = calculate
%    if get(handles.ckbUseSubtractionFrameView,'Value')
%        subtractbool = 3; % 3 = calculate AND view
%    end
%elseif get(handles.ckbUseSubtractionFrameView,'Value')
%    subtractbool = 2; %2 = view
%else subtractbool = 0; %0 = don't use
%end

    
%if subtractbool %if using subtraction frame in some way
%    subframe = get(handles.edtSubtractionFrame,'String');
%    try subframe = round(str2double(subframe)); %if str2double doesn't work
%    catch %set subtractionFrame to startFrame
%        set(handles.edtSubtractionFrame,'String',startFrame);
%        subframe = startFrame;
%    end
%    if subframe == currentFrame %If subfram is current frame, subframe should be the startframe
%        subframe = startFrame;
%    end
%    if currentFrame == startFrame %If already at startframe, there is no frame to subtract.
%        waitfor(msgbox( ... 
%        sprintf('Unable to subtract frame.\nCurrent frame is also the starting frame.'),...
%        'Error'));
%        return
%    end
%    if subframe <= -1 %use negative value to use previous frame
%        if currentFrame > startFrame 
%        subframe = currentFrame-1; %use previous frame
%        else %if currentframe is startframe, there is no previous frame to use
%        waitfor(msgbox( ... 
%        sprintf('Unable to subtract previous frame.\nCurrent frame is also the starting frame.'),...
%        'Error'));
%        return
%        end
%    end
%end

% Get the current image
TestImage1=images(:,:,currentFrame + offsetWrite);
nColumns = size(TestImage1,2);
nRows    = size(TestImage1,1);
Input1 = str2double(get(handles.edtInput1_1,'String'));
Input2 = str2double(get(handles.edtInput1_2,'String'));
Input3 = str2double(get(handles.edtInput1_3,'String'));
Input4 = str2double(get(handles.edtInput1_4,'String'));
Input5 = str2double(get(handles.edtInput1_5,'String'));
Input6 = str2double(get(handles.edtInput1_6,'String'));
Input7 = str2double(get(handles.edtInput1_7,'String'));
Input8 = str2double(get(handles.edtInput1_8,'String'));
x_c =    str2double(get(handles.edtXOrigin, 'String'));

%injStartFrame = str2double(get(handles.edtInjStartFrame,'String'));
Scale = str2num(get(handles.edtScaleFile,'String')); %#ok<ST2NM> %JB{1,14}(1,1);
jetCenter = str2double(get(handles.edtJetCenter1,   'String'));
PercentAdj = str2double(get(handles.edtPercentAdj1,'String'));
time = t1(currentFrame-startFrame+1);  %time after injection first starts
dist = jetPenCalculation(Orifice*1000,Density,700,InjPress,time/1000)/Scale * PercentAdj; % dist into chamber x adjustment factor
JB{currentFrame + offsetRead,1}=[];
JB{currentFrame + offsetRead,2}=[];
JB{currentFrame + offsetRead,3}=[];
JB{currentFrame + offsetRead,4}=[]; 
JB{currentFrame + offsetRead,5}=[];
JB{currentFrame + offsetRead,11}=[];
JB{currentFrame + offsetRead,12}=[];
JB{currentFrame + offsetRead,13}=[]; 


% Mask out large spreading angle near injector LMP 2/4/2009
% Make mask to block out regions not of interest tan(theta/2) of 0.3 
% Edited RKG 8/31/09 to reflect actual calculated y-origin (though x not
% automatic and currently has no box in GUI to change it.
xOrigin = x_c;                                                               % UPDATE THIS LATER!!!
yOrigin = str2double(get(handles.edtJetCenter1,  'String'));
dimIm = size(TestImage1);
%t2=0.3; % tangent(theta/2) tangent of half angle of mask
%t2=0.4; % wider angle for bklda (RKG 4/28/10)
%xpolym = [xOrigin-10 yOrigin/t2 dimIm(2) dimIm(2) (dimIm(1)-yOrigin)/t2]; 
%ypolym = [yOrigin 0 0 dimIm(1) dimIm(1)];
%mask = roipoly(dimIm(1),dimIm(2),xpolym,ypolym); % Region of interest polygon
% Find out if the user wants to mask the liquid core
%liqCoreMask = get(handles.ckbLiqCoreMask,'Value');
%complement = get(handles.ckbComplement,'Value');
%if subtractbool == 3 || subtractbool == 1 %use subtraction frame to calculate
%   %subtract given image from current
%   TestImage1 = TestImage1 - images(:,:,subframe+offsetWrite) + 2000; 
%end
%if subtractbool == 2 %use subtraction frame to view
%   %subtract given image from current
%   TmpTestImage1 = TestImage1 - images(:,:,subframe+offsetWrite)+2000;
%end
%switch JOB;
%    case '(1) Texture (stdv)'
%         % Calculate  and plot the 'X marks the spot' location for this Frame
if get(handles.ckbMarkerActive1,'Value')==1
    XMark = dist; YMark = jetCenter;
    set(handles.ckbXMarkFile1,'Value',1); %%enable the X Mark checkbox file on the GUI
else 
    XMark = []; YMark = [];
end    
%        [x,y,maxJ,minJ]=JBtexture(TestImage1,1,Input1,Input2,Input3, ...
%            Input4,Input5, Input6, Input7, Input8, XMark, YMark, mask, ...
%            liqCoreMask, x_c, complement);

% Labels connected components in image
L = bwlabel(binaryMask,4); % Find the already connected regions within the input image IM 
XMark = []; % Tricks the code into going to the else section (this is really quick & dirty)
if isempty(XMark)==0; % Test if a location for the X mark has been supplied
    
    % Was the mark position calculated as being too far out?
    if XMark > nColumns 
        % If so, divide by 2 and hope for the best
        XMark = nColumns/2;
    end
    LabelNum = L(round(YMark),round(XMark)); % If it has then find the region under the mark X
else
    RegionAreas = regionprops(L, 'area'); % If it hasn't then find the largest region
    Area = cat(1, RegionAreas.Area);
    LabelNum=find(Area==max(Area));
end

if isempty(LabelNum)
    x=[];y=[];maxJ=[];minJ=[];
    return
end
if LabelNum == 0
    x=[];y=[];maxJ=[];minJ=[];
    return
end

JET = zeros(size(binaryMask));
JET(L==LabelNum)=1;

% find the boundary of the region to send back to the GUI as x,y coordinates
%Also send back max and min
JetBoundary = bwboundaries(JET);
[r,c]=find(JET); 
if ~isempty(c) 
    maxJ=max(c);
    minJ=min(c);
else
    maxJ=0; minJ=100;
end

JB{currentFrame + offsetRead,1} = [x y];
JB{currentFrame + offsetRead,2} = [currentFrame val Input1 Input2 Input3 Input4 Input5 Input6 Input7 Input8 jetCenter PercentAdj];
JB{currentFrame + offsetRead,5} = [XMark YMark maxJ minJ];

% Plot boundary over underlying image
set(handles.ckbJB1, 'Value', 1); %set the JB checkbox in the GUI to on
set(handles.edtJBInput1_1, 'String', Input1); %Update the analysis settings to the screen...
set(handles.edtJBInput1_2, 'String', Input2);
set(handles.edtJBInput1_3, 'String', Input3);
set(handles.edtJBInput1_4, 'String', Input4);
set(handles.edtJBInput1_5, 'String', Input5);
set(handles.edtJBInput1_6, 'String', Input6);
set(handles.edtJBInput1_7, 'String', Input7);
set(handles.edtJBInput1_8, 'String', Input8);
set(handles.txtCurrentPercentAdj, 'String', PercentAdj);
set(handles.txtMethod1, 'String', JOB);
boundary = 1;
btnJetPenetration_Callback(hObject, eventdata, handles)
%if subtractbool == 2
%   TestImage1 = TmpTestImage1; 
%end
% Update the GUI plots
udpateGUIPlots(hObject, handles)
